
/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"
#include "boards.h"
#include "olc.h"
#include "plugin.h"
#include "map.h"
#include "shop.h"

/* extern variables */
extern struct str_app_type str_app[];
extern struct room_data *world;
extern struct descriptor_data *descriptor_list;
extern struct char_data *character_list;
extern struct obj_data *object_list;
extern struct player_index_element *player_table;
extern struct index_data *obj_index;
extern struct index_data *mob_index;
extern struct shop_data *shop_index;
extern int top_of_p_table;
extern char *item_condition(struct obj_data *obj);
extern char *position_types[];
extern char *credits;
extern char *news;
extern char *info;
extern char *motd;
extern char *imotd;
extern char *wizlist;
extern char *immlist;
extern char *policies;
extern char *handbook;
extern char *dirs[];
extern char *dirs_look[];
extern char *distances_look[];
extern char *AEdirs[];
extern char *where[];
extern char *color_liquid[];
extern char *fullness[];
extern char *connected_types[];
extern char *class_abbrevs[];
extern char *room_bits[];
extern char *spells[];
extern char *sector_types[];
extern char *race_types[];
extern char *item_size_types[];
extern int top_of_helpt;
extern int top_shop;
extern struct help_index_element *help_table;
extern char *help;
extern int num_fake_chars;
extern char *fake_char_names[100];
extern int fake_char_info[100][2];
/* global */
int boot_high = 0;

/* extern functions */
extern long find_class_bitvector(char argu);
extern int level_exp(int class, int level);
extern void smallmap_look(struct char_data *ch, int size, int dif_room);
extern void show_map(struct char_data *ch, int big);
extern void master_parser(char *buff, struct char_data *ch, struct room_data *room, struct obj_data *obj, struct char_data *mob);
extern void disp_char_sheet(struct char_data *ch);
extern ACMD(do_action);
extern void disp_char_sheet1(struct char_data *ch);
extern struct map_icon_info map_info[];
extern int is_introd(struct char_data *ch, struct char_data *vict);
extern ProximityCheck(struct char_data *ch, struct obj_data *obj, struct char_data *target, int door);
extern byte ListSpellsInSpellBook(struct char_data *ch, struct obj_data *obj);
void ReadMagicBook(struct char_data *ch, struct obj_data *obj);
void CursedScroll(struct obj_data *obj, struct char_data *ch);
int invalid_class(struct char_data *ch, struct obj_data *obj);
extern void make_corpse(struct char_data *ch);
extern char *race_names[];
extern char *class_names[];
extern byte IS_NEARBY(struct char_data *ch, struct char_data *ch1);

void ShowScroll(struct obj_data *obj, struct char_data *ch)
{
  if (GET_OBJ_ORIG_VNUM(obj) > 2100 && GET_OBJ_ORIG_VNUM(obj) < 2116)
    send_to_char("It appears to be a protection scroll of some sort.\r\n", ch);
  else if (GET_OBJ_ORIG_VNUM(obj) == 2116)
    CursedScroll(obj, ch);
  else if (GET_OBJ_ORIG_VNUM(obj) > 2116 && GET_OBJ_ORIG_VNUM(obj) < 2200) {
    send_to_char("This appears to be a magical scroll of spells.\r\n", ch);
  }
}

void show_obj_to_char(struct obj_data *object, struct char_data *ch,
		      int mode)
{
  bool found;
  int Distance = 5, size = 1;
  int Direction = -1;

  *buf = '\0';
  if ((mode == 0) && object->description)
    strcpy(buf, object->description);
  else if (object->short_description && ((mode == 1) ||
			    (mode == 2) || (mode == 3) || (mode == 4))) {
    strcpy(buf, object->short_description);
  } else if (object->short_description && mode == 8) {	/* do_equip calls */
    sprintf(buf, "   <&+Lcontains&n>   %s", object->short_description);
  } else if (mode == 5) {
    if (GET_OBJ_TYPE(object) == ITEM_NOTE) {
      if (object->action_description) {
	send_to_char(CLS(ch->desc), ch);
	strcpy(buf, "There is something written upon it:\r\n\r\n");
	strcat(buf, object->action_description);
	send_to_char(buf, ch);
      } else
	act("It's blank.", FALSE, ch, 0, 0, TO_CHAR);
      return;
    } else if (GET_OBJ_TYPE(object) == ITEM_BOARD) {
      Board_show_board(GET_OBJ_VNUM(object), ch);
    } else if (GET_OBJ_TYPE(object) == ITEM_SCROLL) {
      ShowScroll(object, ch);
    } else if (GET_OBJ_TYPE(object) != ITEM_DRINKCON) {
      strcpy(buf, "You see nothing special..");
    } else			/* ITEM_TYPE == ITEM_DRINKCON||FOUNTAIN */
      strcpy(buf, "It looks like a drink container.");
  } else if (object->short_description && mode == 7) {

    size = GET_OBJ_SIZE(object);
    if (size == ITEM_SIZE_MAGICAL)	/* magical would be seen forever */
      size = ITEM_SIZE_MEDIUM;

    Distance = (size + GET_SIZE(ch) + 3) / 2;

    if (objWithinRangeofChar(ch, object, Distance)) {
      Distance = distBetweenCharAndObj(ch, object);
      Direction = angleBetweenCharAndObj(ch, object);
      strcpy(buf, object->short_description);
      CAP(buf);
      sprintf(buf, "%s is %s %s", buf, distances_look[(Distance <= 7 ? Distance : 7)], dirs_look[Direction]);
    } else {
      return;
    }
  }
  if (mode != 3 && mode != 7 && mode != 8) {
    found = FALSE;

    if (IS_OBJ_STAT(object, ITEM_INVISIBLE)) {
      strcat(buf, " (&+Linvis&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_NOSHOW) && IS_TRUSTED(ch)) {
      strcat(buf, " (&+LNOSHOW&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_CONCEALED) && IS_TRUSTED(ch)) {
      strcat(buf, " (&+Lconcealed&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_SECRET) && IS_TRUSTED(ch)) {
      strcat(buf, " (&+Lsecret&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_BURIED) && IS_TRUSTED(ch)) {
      strcat(buf, " (&+Lburied&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_MAGIC) && (IS_TRUSTED(ch) || IS_DETECTING(ch, DETECTING_MAGIC))) {
      strcat(buf, " (&+bmagic&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_GLOW)) {
      strcat(buf, " (&+Mglowing&n)");
      found = TRUE;
    }
    if (IS_OBJ_STAT(object, ITEM_LIT)) {
      strcat(buf, " (&+Willuminating&n)");
      found = TRUE;
    }
    if (mode != 7 && mode != 0)
      sprintf(buf, "%s &+c%s&n (&+m%s&n)", buf, item_condition(object), item_size_types[(int) GET_OBJ_SIZE(object)]);
    found = TRUE;
  }
  strcat(buf, "\r\n");
  /* decipher any fancy text first */
  master_parser(buf, ch, NULL, object, NULL);

  /* add some godly views */
  sprintf(buf2, buf);
  if (PRF_FLAGGED(ch, PRF_ROOMFLAGS) && IS_TRUSTED(ch)) {
    sprintf(buf, "&+B[%5d]&n %s", GET_OBJ_VNUM(object), buf2);
  }
  /* now let them see it */
  page_string(ch->desc, buf, 1);
}


void list_obj_to_char(struct obj_data *list, struct char_data *ch, int mode,
		      bool show, int xyz)
{
  struct obj_data *i, *j;
  bool found;
  int num;
  int old_mode;

  old_mode = mode;
  found = FALSE;
  for (i = list; i; i = i->next_content) {
    num = 0;
    for (j = list; j != i; j = j->next_content)
      if (j->item_number == NOTHING || j->item_number == i->item_number) {
	if ((GET_OBJ_X_CORD(j) == GET_OBJ_X_CORD(i) &&
	     GET_OBJ_Y_CORD(j) == GET_OBJ_Y_CORD(i) &&
	     GET_OBJ_Z_CORD(j) == GET_OBJ_Z_CORD(i)) &&
	    (strcmp(j->short_description, i->short_description) == 0))
	  break;
      }
    if (j != i)
      continue;
    for (j = i; j; j = j->next_content)
      if (j->item_number == NOTHING || j->item_number == i->item_number) {
	if ((GET_OBJ_X_CORD(j) == GET_OBJ_X_CORD(i) &&
	     GET_OBJ_Y_CORD(j) == GET_OBJ_Y_CORD(i) &&
	     GET_OBJ_Z_CORD(j) == GET_OBJ_Z_CORD(i)) &&
	    j->short_description && i->short_description &&
	    (strcmp(j->short_description, i->short_description) == 0))
	  num++;
      }
    if (xyz && (GET_X_CORD(ch) != GET_OBJ_X_CORD(i) ||
		GET_Y_CORD(ch) != GET_OBJ_Y_CORD(i) ||
		GET_Z_CORD(ch) != GET_OBJ_Z_CORD(i))) {
      old_mode = mode;
      mode = 7;
    }
    if (CAN_SEE_OBJ(ch, i) && !i->people) {	/* don't show furniture if sat upon      */
      if (num != 1) {		/* it will be shown strung to their name */
	sprintf(buf, "(%2i) ", num);
	send_to_char(buf, ch);
      }
      show_obj_to_char(i, ch, mode);
      found = TRUE;
    }
    mode = old_mode;
  }
  if (!found && show)
    send_to_char(" Nothing.\r\n", ch);
}

void diag_char_to_char(struct char_data *i, struct char_data *ch)
{
  int percent;

  if (GET_MAX_HIT(i) > 0)
    percent = (100 * GET_HIT(i)) / GET_MAX_HIT(i);
  else
    percent = -1;		/* How could MAX_HIT be < 1?? */

  strcpy(buf, PERS(i, ch, TRUE));
  CAP(buf);

  if (percent >= 100)
    strcat(buf, " &+Gis in excellent condition");
  else if (percent >= 90)
    strcat(buf, " &+yhas a few scratches");
  else if (percent >= 75)
    strcat(buf, " &+Yhas some small wounds and bruises");
  else if (percent >= 50)
    strcat(buf, " &+Mhas quite a few wounds");
  else if (percent >= 30)
    strcat(buf, " *+mhas some big nasty wounds and scratches");
  else if (percent >= 15)
    strcat(buf, " &+Rlooks pretty hurt");
  else if (percent >= 0)
    strcat(buf, " &+ris in awful condition");
  else
    strcat(buf, " &+ris &+Rbleeding&N&+r awfully from big wounds");
  strcat(buf, "&n. (facing ");
  strcat(buf, dirs[GET_FACING(i)]);
  strcat(buf, ")\r\n");

  send_to_char(buf, ch);
}


void look_at_char(struct char_data *i, struct char_data *ch)
{
  int j, found;
  struct obj_data *tmp_obj;
  int Distance = (GET_SIZE(i) + GET_SIZE(ch) + 3) / 2;

  if (!victWithinRangeofChar(ch, i, Distance)) {
    send_to_char(NOPERSON, ch);
    return;
  }
  if (!ch->desc)
    return;

  if (i->player.description)
    send_to_char(i->player.description, ch);
  else
    act("You see nothing special about $m.", FALSE, i, 0, ch, TO_VICT);

  diag_char_to_char(i, ch);

  found = FALSE;
  for (j = 0; !found && j < NUM_WEARS; j++)
    if (GET_EQ(i, j) && CAN_SEE_OBJ(ch, GET_EQ(i, j)))
      found = TRUE;

  if (found) {
    act("\r\n$n is using:", FALSE, i, 0, ch, TO_VICT);
    for (j = 0; j < NUM_WEARS; j++)
      if (GET_EQ(i, j) && CAN_SEE_OBJ(ch, GET_EQ(i, j))) {
	if (j == WEAR_HOLD) {
	  if (IS_OBJ_STAT(GET_EQ(i, j), ITEM_TWOHANDS))
	    send_to_char(where[NUM_WEARS + 3], ch);
	  else if (GET_DOM_HAND(i) == HAND_RIGHT)
	    send_to_char(where[NUM_WEARS], ch);
	  else
	    send_to_char(where[NUM_WEARS + 1], ch);
	} else if (j == WEAR_WIELD) {
	  if (IS_OBJ_STAT(GET_EQ(i, j), ITEM_TWOHANDS) ||
	      NEEDS_TWO_HANDS(i, GET_EQ(i, j)))
	    send_to_char(where[NUM_WEARS + 2], ch);
	  else if (IS_OBJ_STAT(GET_EQ(i, j), ITEM_ONEORTWOHANDS) && GET_EQ(i, WEAR_WIELD2))
	    send_to_char(where[NUM_WEARS + 1], ch);
	  else if (GET_DOM_HAND(i) == HAND_RIGHT)
	    send_to_char(where[NUM_WEARS], ch);
	  else
	    send_to_char(where[NUM_WEARS + 1], ch);
	} else if ((j == WEAR_SHIELD) || (j == WEAR_WIELD2) || j == WEAR_HOLD2) {
	  if (GET_DOM_HAND(i) == HAND_RIGHT)
	    send_to_char(where[NUM_WEARS + 1], ch);
	  else
	    send_to_char(where[NUM_WEARS], ch);
	} else
	  send_to_char(where[j], ch);
	show_obj_to_char(GET_EQ(i, j), ch, 1);
	if (IS_SCABBARD(GET_EQ(i, j))) {
	  if (GET_EQ(i, j)->contains && CAN_SEE_OBJ(ch, GET_EQ(i, j)))
	    list_obj_to_char(GET_EQ(i, j)->contains, ch, 8, TRUE, FALSE);
	  else
	    send_to_char("    <&+Lcontains&n>   Empty.\r\n", ch);
	}
      }
  }
  if (ch != i && IS_TRUSTED(ch)) {
    found = FALSE;
    send_to_char("\r\nInventory:\r\n", ch);
    for (tmp_obj = i->carrying; tmp_obj; tmp_obj = tmp_obj->next_content) {
      if (CAN_SEE_OBJ(ch, tmp_obj) && (number(0, 20) < GET_LEVEL(ch))) {
	show_obj_to_char(tmp_obj, ch, 1);
	found = TRUE;
      }
    }

    if (!found)
      send_to_char("You can't see anything.\r\n", ch);
  }
}


void list_all_char(struct char_data *i, struct char_data *ch, int num)
{
  int Direction = -1;
  int Distance = (GET_SIZE(i) + GET_SIZE(ch) + 3) / 2;

  if (!victWithinRangeofChar(ch, i, Distance))
    return;

  Distance = distBetweenCharAndVict(ch, i);
  Direction = angleBetweenCharAndVict(ch, i);

  /* cloak of displacement */
  if (GET_EQ(ch, WEAR_ABOUT) && GET_OBJ_ORIG_VNUM(GET_EQ(ch, WEAR_ABOUT)) == 2702) {
    Distance = number(Distance - 2, Distance + 2);
    Direction = number(0, NUM_DIRS);
  }
  *buf = '\0';

  if (IS_NPC(i) && PRF_FLAGGED(ch, PRF_ROOMFLAGS) && IS_TRUSTED(ch))
    sprintf(buf, "&+B[%5d]&n ", GET_MOB_VNUM(i));

  if (IS_NPC(i) && i->player.long_descr && GET_POS(i) == GET_DEFAULT_POS(i))
    strcat(buf, i->player.long_descr);

  else if (IS_PC(i)) {
    if (is_introd(ch, i))
      strcat(buf, GET_NAME(i));
    else
      strcat(buf, race_names[GET_RACE(i)]);
  } else
    strcat(buf, GET_NAME(i));
  CAP(buf);
  if (IS_PC(i))
    if (strlen(GET_TITLE(i)) >= 1)
      sprintf(buf, "%s %s", buf, GET_TITLE(i));
  /* remove newlines, etc */
  while ((buf[strlen(buf) - 1] == '\r') ||
	 (buf[strlen(buf) - 1] == '\n') ||
	 (buf[strlen(buf) - 1] == '.') ||
	 (buf[strlen(buf) - 1] == '!') ||
	 (buf[strlen(buf) - 1] == ' ')) {
    buf[strlen(buf) - 1] = '\0';
  }

  /* basic name is done */

  if (IS_AFFECTED(i, AFF_INVISIBLE) && (IS_DETECTING(ch, DETECTING_INVIS) || IS_TRUSTED(ch)))
    strcat(buf, " (invisible)");
  if (IS_TRUSTED(ch)) {
    if (IS_AFFECTED(i, AFF_HIDE))
      strcat(buf, " (hidden)");
    if (!IS_NPC(i) && !i->desc)
      strcat(buf, " (linkless)");
  }
  if (PLR_FLAGGED(i, PLR_WRITING))
    strcat(buf, " (writing)");

  if (i->char_specials.timer >= 5)
    strcat(buf, " (&+RAFK&n)");

  if (world[i->in_room].number <= 0)
    strcat(buf, " (&+Lvoided&n)");

  if (world[i->in_room].number == 1)
    strcat(buf, " (&+Llimbo&n)");

  if (FURNITURE(i) && FURNITURE(i)->in_room == i->in_room) {
    if (IS_SAME_CORD(ch, i))
      sprintf(buf, "%s is here %s on %s.", buf, position_types[(int) GET_POS(i)],
	      FURNITURE(i)->short_description);
    else {
      Distance = GET_SIZE(i) + 2;
      if (victWithinRangeofChar(ch, i, Distance)) {
	Distance = distBetweenCharAndVict(ch, i);
	Direction = angleBetweenCharAndVict(ch, i);
	sprintf(buf, "%s is %s %s, %s on %s.", buf, distances_look[(Distance <= 7 ? Distance : 7)], dirs_look[Direction],
		position_types[(int) GET_POS(i)], FURNITURE(i)->short_description);
      } else
	return;
    }
  } else {
    switch (GET_STAT(i)) {
    case STAT_DEAD:
      strcat(buf, " lies quite dead");
      /* bug! kill them off... */
      make_corpse(i);
      extract_char(i);
      break;
    case STAT_DYING:
      strcat(buf, " lies mortally wounded");
      break;
    case STAT_INCAP:
      strcat(buf, " lying incapacitated is");
      break;
    case STAT_SLEEPING:
      switch (GET_POS(i)) {
      case POS_PRONE:
	strcat(buf, " is stretched out, sound asleep");
	break;
      case POS_SITTING:
	strcat(buf, " has nodded off, sitting");
	break;
      case POS_KNEELING:
	strcat(buf, " is asleep, kneeling");
	break;
      case POS_STANDING:
	strcat(buf, " stands, apparently asleep");
	break;
      }
      if (IS_AFFECTED4(i, AFF4_BOUND))
	strcat(buf, " and restrained");
      break;
    case STAT_RESTING:
      switch (GET_POS(i)) {
      case POS_PRONE:
	strcat(buf, " is sprawled out, resting");
	break;
      case POS_SITTING:
	strcat(buf, " sits resting");
	break;
      case POS_KNEELING:
	strcat(buf, " squats comfortably");
	break;
      case POS_STANDING:
	strcat(buf, " stands at ease");
	break;
      }
      if (IS_AFFECTED4(i, AFF4_KNOCKED_OUT))
	strcat(buf, " and appears to be unconscious");
      if (IS_AFFECTED4(i, AFF4_BOUND))
	strcat(buf, " and restrained");
      break;
    case STAT_NORMAL:
      if (!RIDING(i) && GET_Z_CORD(i) == 0)
	switch (GET_POS(i)) {
	case POS_PRONE:
	  strcat(buf, " is lying");
	  break;
	case POS_SITTING:
	  strcat(buf, " sits");
	  break;
	case POS_KNEELING:
	  strcat(buf, " crouches");
	  break;
	case POS_STANDING:
	  strcat(buf, " stands");
	  break;
	}
      if (IS_AFFECTED4(i, AFF4_KNOCKED_OUT))
	strcat(buf, " unconscious");
      if (IS_AFFECTED4(i, AFF4_BOUND))
	strcat(buf, ", restrained");
      else if (GET_Z_CORD(i) > 0)
	strcat(buf, " floats in mid-air");
      else if (IS_AFFECTED(i, AFF_LEVITATE))
	strcat(buf, ", floating");
      break;
    }
    if (!IS_NEARBY(ch, i))
      sprintf(buf, "%s %s %s", buf, distances_look[(Distance <= 7 ? Distance : 7)], dirs_look[Direction]);
    else
      strcat(buf, " here");

    if (RIDING(i)) {
      strcat(buf, " atop ");
      if (IS_PC(i) && (RIDING(i) == ch))
	strcat(buf, " YOU");
      else {
	if (i->in_room == RIDING(i)->in_room) {
	  if (CAN_SEE(ch, RIDING(i))) {
	    if (is_introd(ch, RIDING(i)))
	      strcat(buf, GET_NAME(RIDING(i)));
	    else
	      strcat(buf, race_names[GET_RACE(RIDING(i))]);
	  } else {
	    /* invis/hiding mount */
	    strcat(buf, "a cushion of air");
	  }
	} else
	  strcat(buf, "someone who has already left");
      }
    } else if (RIDDEN_BY(i) && (CAN_SEE(ch, RIDDEN_BY(i)) || ch == RIDDEN_BY(i))) {
      strcat(buf, " ridden by");
      if (RIDDEN_BY(i) == ch)
	strcat(buf, " you");
      else {
	if (i->in_room == RIDDEN_BY(i)->in_room) {
	  if (CAN_SEE(ch, RIDDEN_BY(i))) {
	    if (is_introd(ch, RIDDEN_BY(i)))
	      strcat(buf, GET_NAME(RIDDEN_BY(i)));
	    else
	      strcat(buf, race_names[GET_RACE(RIDDEN_BY(i))]);
	  }
	} else
	  strcat(buf, "someone who has already left");
      }
    }
    if (VEHICLE(i))
      strcat(buf, " hitched to something or other");

    if (!FIGHTING(i)) {
      strcat(buf, ".");
    } else {
      strcat(buf, ", fighting ");
      if (FIGHTING(i) == ch)
	strcat(buf, "YOU!");
      else {
	if (i->in_room == FIGHTING(i)->in_room) {
	  if (IS_NPC(FIGHTING(i))) {
	    strcat(buf, GET_NAME(FIGHTING(i)));
	  } else {
	    if (is_introd(ch, FIGHTING(i)))
	      strcat(buf, GET_NAME(FIGHTING(i)));
	    else
	      strcat(buf, race_names[GET_RACE(FIGHTING(i))]);
	  }
	  strcat(buf, ".");
	} else
	  strcat(buf, "someone who has already left.");
      }
    }
  }

  if (IS_EVIL(i) && (IS_DETECTING(ch, DETECTING_EVIL) ||
		     IS_DETECTING(ch, DETECTING_ALIGN)))
    strcat(buf, " (&+RRed Aura&n)");
  else if (IS_GOOD(i) && (IS_DETECTING(ch, DETECTING_GOOD) ||
			  IS_DETECTING(ch, DETECTING_ALIGN)))
    strcat(buf, " (&+YGold Aura&n)");

  if (IS_AFFECTED(i, AFF_CHARM) &&
      !affected_by_spell(i, SPELL_UNDETECTABLE_CHARM) &&
      affected_by_spell(ch, SPELL_DETECT_CHARM))
    strcat(buf, " (Charmed)");

  if (num > 1) {
    while ((buf[strlen(buf) - 1] == '\r') ||
	   (buf[strlen(buf) - 1] == '\n') ||
	   (buf[strlen(buf) - 1] == ' ')) {
      buf[strlen(buf) - 1] = '\0';
    }
    sprintf(buf2, " [%d]", num);
    strcat(buf, buf2);
  }
  strcat(buf, "\r\n");
  send_to_char(buf, ch);
}



void list_char_to_char(struct char_data *list, struct char_data *ch)
{
  struct char_data *i, *plr_list[100];
  int num, counter, locate_list[100], found = FALSE;

  num = 0;

  for (i = list; i; i = i->next_in_room) {
    if (i != ch) {
      if ((OUTSIDE(ch) && OUTSIDE(i)) || (!OUTSIDE(ch) && !OUTSIDE(i))) {
	if (CAN_SEE(ch, i)) {
	  if (num < 100) {
	    found = FALSE;
	    for (counter = 0; (counter < num && !found); counter++) {
	      if (i->nr == plr_list[counter]->nr &&

/* for odd reasons, you may want to seperate same nr mobs by factors 
   other than position, the aff flags, and the fighters. (perhaps you want 
   to list switched chars differently.. or polymorphed chars?) */

		  (GET_POS(i) == GET_POS(plr_list[counter])) &&
		  (AFF_FLAGS(i) == AFF_FLAGS(plr_list[counter])) &&
		  (IS_SAME_CORD(i, plr_list[counter])) &&
		  (FIGHTING(i) == FIGHTING(plr_list[counter])) &&
		  !strcmp(GET_NAME(i), GET_NAME(plr_list[counter]))) {
		locate_list[counter] += 1;
		found = TRUE;
	      }
	    }
	    if (!found) {
	      plr_list[num] = i;
	      locate_list[num] = 1;
	      num++;
	    }
	  } else {
	    list_all_char(i, ch, 0);
	  }
	}
      }
    }
  }
  if (num) {
    for (counter = 0; counter < num; counter++) {
      if (locate_list[counter] > 1) {
	list_all_char(plr_list[counter], ch, locate_list[counter]);
      } else {
	list_all_char(plr_list[counter], ch, 0);
      }
    }
  }
}



ACMD(do_exits)
{
  int door;

  *buf = '\0';

  if (IS_AFFECTED(ch, AFF_BLIND)) {
    send_to_char("You can't see a damned thing, you're blind!\r\n", ch);
    return;
  }
  for (door = 0; door < NUM_OF_DIRS; door++)
    if (EXIT(ch, door) && EXIT(ch, door)->to_room > 1) {
/*      !IS_SET(EXIT(ch, door)->exit_info, EX_CLOSED)) { */
      if (GET_LEVEL(ch) >= LVL_IMMORT)
	sprintf(buf2, "%-5s - [%5d] %s\r\n", dirs[door],
		world[EXIT(ch, door)->to_room].number,
		world[EXIT(ch, door)->to_room].name);
      else {
	sprintf(buf2, "%-5s - ", dirs[door]);
	if (IS_DARK(EXIT(ch, door)->to_room) && !CAN_SEE_IN_DARK(ch))
	  strcat(buf2, "Too dark to tell\r\n");
	else {
	  strcat(buf2, world[EXIT(ch, door)->to_room].name);
	  strcat(buf2, "\r\n");
	}
      }
      strcat(buf, CAP(buf2));
    }
  send_to_char("Exits:\r\n", ch);
  if (*buf)
    send_to_char(buf, ch);
  else
    send_to_char(" None.\r\n", ch);
}



void look_at_room(struct char_data *ch, int mode)
{
  char Gbuf[MAX_STRING_LENGTH], Gbuf1[MAX_STRING_LENGTH];
  char Gbuf2[MAX_STRING_LENGTH], Gbuf3[MAX_STRING_LENGTH];
  char *roof_buf;
  int clair = FALSE, room, dir, shop_nr;

  if (!ch->desc)
    return;

  if (IS_DARK(ch->in_room) && !CAN_SEE_IN_DARK(ch)) {
    return;
  } else if (IS_AFFECTED(ch, AFF_BLIND)) {
    send_to_char("You see nothing but infinite darkness...\r\n", ch);
    return;
  }
  clair = IS_AFFECTED4(ch, AFF4_CLAIR);

  /* temp calling, prolly change function parameters a bit later */
  if ((mode != 2) && (!clair))
    smallmap_look(ch, view_distance(ch), -1);

  send_to_char("\r\n", ch);

  if (!OUTSIDE(ch) && !UNDERGROUND(ch) && GET_Z_CORD(ch) >= GET_Z_SIZE(ch->in_room))
    roof_buf = strdup("On the roof of ");
  else
    roof_buf = strdup("");

  if (PRF_FLAGGED(ch, PRF_ROOMFLAGS) && IS_TRUSTED(ch)) {
    Gbuf3[0] = '\0';
    for (shop_nr = 0; shop_nr < top_shop; shop_nr++) {
      if (SHOP_ROOM(shop_nr, 0) == world[ch->in_room].number) {
	sprintf(Gbuf3, " &+YSHOP %d&n ", (shop_nr + 1));
	break;
      }
    }
    sprintbit((ulong) ROOM_FLAGS(ch->in_room), room_bits, Gbuf);
    sprinttype(SECT(ch->in_room), sector_types, Gbuf1);
    sprintf(Gbuf2, "&+B[%5d]&n %s%s ", world[ch->in_room].number, roof_buf,
	    world[ch->in_room].name);
    send_to_char(Gbuf2, ch);
    sprintf(Gbuf2, "&+B[%s] [%s]%s%s%s&n\r\n", Gbuf, Gbuf1, (world[ch->in_room].func == NULL) ? "" : " &+rProc&n", world[ch->in_room].shape == ROOM_SHAPE_SQUARE ? " &+rOLC Shape&n" : "", Gbuf3 ? Gbuf3 : "");
    send_to_char(Gbuf2, ch);
  } else {
    if (IS_GREY_TERM(ch->desc)) {
      send_to_char(PLUGIN_ROOM_START, ch);
      send_to_char(roof_buf, ch);
      send_to_char(strip_color(world[ch->in_room].name), ch);
      send_to_char(PLUGIN_ROOM_END, ch);
    } else {
      send_to_char(roof_buf, ch);
      send_to_char(world[ch->in_room].name, ch);
      send_to_char("\r\n", ch);
    }
  }

  if (mode == 1 || ROOM_FLAGGED(ch->in_room, ROOM_DEATH))
    /* we allow non descriptions, and force some as well */
    if (world[ch->in_room].description &&
	str_cmp(world[ch->in_room].description, "You are in an unfinished room."))
      send_to_char(world[ch->in_room].description, ch);

  /* swimmers */
  if (GET_Z_CORD(ch) < 0)
    return;

  /* roof walkers */
  if (!OUTSIDE(ch) && GET_Z_CORD(ch) >= GET_Z_SIZE(ch->in_room))
    return;

  /* now list characters & objects */
  send_to_char("----------\r\n", ch);
  list_obj_to_char(world[ch->in_room].contents, ch, 0, FALSE, TRUE);
  room = ch->in_room;
  /* loop for mobs */
  for (dir = -1; dir < NUM_OF_DIRS; dir++) {
    if (dir == UP || dir == DOWN)
      continue;
    if (dir > -1 && (
		      !world[ch->in_room].dir_option[dir] ||
		      DRAW_WALL_ONLY(ch->in_room, dir) ||
		      world[ch->in_room].dir_option[dir]->to_room < 1 ||
/*                    room == ch->in_room ||     looped rooms */
      IS_SET(world[ch->in_room].dir_option[dir]->exit_info, EX_ISDOOR) ||
	     IS_SET(VIRTUAL_EXIT(ch->in_room, dir)->exit_info, EX_CLOSED)
	))
      continue;
    if (dir == -1)
      room = ch->in_room;
    else
      room = world[ch->in_room].dir_option[dir]->to_room;

    list_char_to_char(world[room].people, ch);
  }
}



void look_in_direction(struct char_data *ch, int dir)
{
  if (EXIT(ch, dir) && CAN_SEE_EXIT(ch, ch->in_room, dir)) {
    if (EXIT(ch, dir)->general_description)
      send_to_char(EXIT(ch, dir)->general_description, ch);
    else
      send_to_char("You see nothing special.\r\n", ch);

    if (IS_SET(EXIT(ch, dir)->exit_info, EX_CLOSED) && EXIT(ch, dir)->keyword) {
      sprintf(buf, "The %s is closed.\r\n", fname(EXIT(ch, dir)->keyword));
      send_to_char(buf, ch);
    } else if (IS_SET(EXIT(ch, dir)->exit_info, EX_ISDOOR) && EXIT(ch, dir)->keyword) {
      sprintf(buf, "The %s is open.\r\n", fname(EXIT(ch, dir)->keyword));
      send_to_char(buf, ch);
    }
  } else
    send_to_char("Nothing special there...\r\n", ch);
}



void look_in_obj(struct char_data *ch, char *argu)
{
  struct obj_data *obj = NULL;
  struct char_data *dummy = NULL;
  int amt, bits;

  if (!*argu)
    send_to_char("Look in what?\r\n", ch);
  else if (!(bits = generic_find(argu, FIND_OBJ_INV | FIND_OBJ_ROOM |
				 FIND_OBJ_EQUIP, ch, &dummy, &obj))) {
    sprintf(buf, "There doesn't seem to be %s %s here.\r\n", AN(argu), argu);
    send_to_char(buf, ch);
  } else if (!((GET_OBJ_TYPE(obj) == ITEM_DRINKCON) ||
	       (GET_OBJ_TYPE(obj) == ITEM_FOUNTAIN) ||
	       (GET_OBJ_TYPE(obj) == ITEM_FURNITURE && GET_OBJ_VAL(obj, 4) == FURN_BOOKCASE) ||
	       (GET_OBJ_TYPE(obj) == ITEM_FURNITURE && GET_OBJ_VAL(obj, 4) == FURN_DESK) ||
	       (GET_OBJ_TYPE(obj) == ITEM_CONTAINER) ||
	       (GET_OBJ_TYPE(obj) == ITEM_STORAGE) ||
	       (GET_OBJ_TYPE(obj) == ITEM_CORPSE) ||
	       (GET_OBJ_TYPE(obj) == ITEM_SCROLL) ||
	       (GET_OBJ_TYPE(obj) == ITEM_BOOK)))
    send_to_char("There's nothing inside that!\r\n", ch);
  else {
    if ((GET_OBJ_TYPE(obj) == ITEM_CONTAINER) ||
	(GET_OBJ_TYPE(obj) == ITEM_STORAGE) ||
	(GET_OBJ_TYPE(obj) == ITEM_SCABBARD) ||
	(GET_OBJ_TYPE(obj) == ITEM_FURNITURE)) {
      if (IS_SET(GET_OBJ_VAL(obj, 1), CONT_CLOSED))
	send_to_char("It is closed.\r\n", ch);
      else {
	send_to_char(fname(obj->name), ch);
	switch (bits) {
	case FIND_OBJ_INV:
	  send_to_char(" (carried): \r\n", ch);
	  break;
	case FIND_OBJ_ROOM:
	  send_to_char(" (here): \r\n", ch);
	  break;
	case FIND_OBJ_EQUIP:
	  send_to_char(" (used): \r\n", ch);
	  break;
	}

	list_obj_to_char(obj->contains, ch, 2, TRUE, FALSE);
      }
    } else if (GET_OBJ_TYPE(obj) == ITEM_CORPSE) {
      send_to_char(" (on corpse): \r\n", ch);
      list_obj_to_char(obj->contains, ch, 2, TRUE, FALSE);
    } else if (GET_OBJ_TYPE(obj) == ITEM_BOOK) {
      if (!ListSpellsInSpellBook(ch, obj))
	ReadMagicBook(ch, obj);
    } else if (GET_OBJ_TYPE(obj) == ITEM_SCROLL) {
      /* failure should trigger cursed_scroll */
      ListSpellsInSpellBook(ch, obj);
    } else {			/* item must be a fountain or drink container */
      if (GET_OBJ_VAL(obj, 1) <= 0)
	send_to_char("It is empty.\r\n", ch);
      else {
	if (GET_OBJ_VAL(obj, 0) <= 0 || GET_OBJ_VAL(obj, 1) > GET_OBJ_VAL(obj, 0)) {
	  sprintf(buf, "Its contents seem somewhat murky.\r\n");	/* BUG */
	} else {
	  amt = (GET_OBJ_VAL(obj, 1) * 3) / GET_OBJ_VAL(obj, 0);
	  sprinttype(GET_OBJ_VAL(obj, 2), color_liquid, buf2);
	  sprintf(buf, "It's %sfull of a %s liquid.\r\n", fullness[amt], buf2);
	}
	send_to_char(buf, ch);
      }
    }
  }
}



char *
 find_exdesc(char *word, struct extra_descr_data *list)
{
  struct extra_descr_data *i;

  for (i = list; i; i = i->next)
    if (isname(word, i->keyword))
      return (i->description);

  return NULL;
}


/*
 * Given the argument "look at <target>", figure out what object or char
 * matches the target.  First, see if there is another char in the room
 * with the name.  Then check local objs for exdescs.
 */
void look_at_target(struct char_data *ch, char *argu, int read)
{
  int bits, found = 0, j, msg = 1;
  struct char_data *found_char = NULL;
  struct obj_data *obj = NULL, *found_obj = NULL;
  char *desc;
  char number[MAX_STRING_LENGTH];
  byte clair = FALSE;

  if (!ch->desc)
    return;

  if (!*argu) {
    send_to_char("Look at what?\r\n", ch);
    return;
  }
  if (read == 1) {
    for (obj = ch->carrying; obj; obj = obj->next_content) {
      if (GET_OBJ_TYPE(obj) == ITEM_BOARD || GET_OBJ_TYPE(obj) == ITEM_NOTE) {
	found = 1;
	break;
      }
    }
    if (!obj) {
      for (obj = world[ch->in_room].contents; obj; obj = obj->next_content) {
	if (GET_OBJ_TYPE(obj) == ITEM_BOARD && ProximityCheck(ch, obj, NULL, -1)) {
	  found = 1;		/* board found, distance is okay */
	  break;
	} else if (GET_OBJ_TYPE(obj) == ITEM_BOARD)
	  found = 2;		/* board found, distance is not okay */
      }
    }
    if (found == 2 && !strcmp(argu, "board")) {
      send_to_char("That is much too far away to read.\r\n", ch);
      return;
    }
    if (obj) {
      argu = one_argument(argu, number);
      if (!*number)
	send_to_char("Read what?\r\n", ch);
      if (isname(number, obj->name)) {
	Board_show_board(GET_OBJ_VNUM(obj), ch);
	/* Okay, here i'm faced with the fact that the person could be
	   entering in something like 'read 5' or 'read 4.mail' .. so, whats the
	   difference between the two?  Well, there's a period in the second,
	   so, we'll just stick with that basic difference */
      } else if ((!isdigit(*number) || (!(msg = atoi(number)))) ||
		 (strchr(number, '.'))) {
	sprintf(argu, "%s %s", number, argu);
	look_at_target(ch, argu, 0);
      } else {
	Board_display_msg(GET_OBJ_VNUM(obj), ch, msg);
      }
    }
    if (!found && read)		/* this should already be established, but... */
      send_to_char("Read what?\r\n", ch);
  } else {

    bits = generic_find(argu, FIND_OBJ_INV | FIND_OBJ_ROOM | FIND_OBJ_EQUIP |
			FIND_CHAR_ROOM, ch, &found_char, &found_obj);

    clair = (IS_AFFECTED4(ch, AFF4_CLAIR));

    /* Is the target a character? */
    if (found_char != NULL) {
      look_at_char(found_char, ch);
      if (ch != found_char) {
	if (CAN_SEE(found_char, ch) && !clair)
	  act("$n looks at you.", TRUE, ch, 0, found_char, TO_VICT);
	if (!clair)
	  act("$n looks at $N.", TRUE, ch, 0, found_char, TO_NOTVICT);
      }
      return;
    }
    /* Does the argument match an extra desc in the room? */
    if ((desc = find_exdesc(arg, world[ch->in_room].ex_description)) != NULL) {
      page_string(ch->desc, desc, 0);
      return;
    }
    /* Does the argument match an extra desc in the char's equipment? */
    for (j = 0; j < NUM_WEARS && !found; j++)
      if (GET_EQ(ch, j) && CAN_SEE_OBJ(ch, GET_EQ(ch, j)))
	if ((desc = find_exdesc(arg, GET_EQ(ch, j)->ex_description)) != NULL) {
	  send_to_char(desc, ch);
	  found = 1;
	}
    /* Does the argument match an extra desc in the char's inventory? */
    for (obj = ch->carrying; obj && !found; obj = obj->next_content) {
      if (CAN_SEE_OBJ(ch, obj))
	if ((desc = find_exdesc(arg, obj->ex_description)) != NULL) {
	  if (GET_OBJ_TYPE(obj) == ITEM_BOARD) {
	    Board_show_board(GET_OBJ_VNUM(obj), ch);
	  } else
	    send_to_char(desc, ch);
	  found = 1;
	}
    }

    /* Does the argument match an extra desc of an object in the room? */
    for (obj = world[ch->in_room].contents; obj && !found; obj = obj->next_content)
      if (CAN_SEE_OBJ(ch, obj))
	if ((desc = find_exdesc(arg, obj->ex_description)) != NULL) {
	  if (GET_OBJ_TYPE(obj) == ITEM_BOARD) {
	    Board_show_board(GET_OBJ_VNUM(obj), ch);
	  } else
	    send_to_char(desc, ch);
	  found = 1;
	}
    if (bits) {			/* If an object was found back in
				 * generic_find */
      if (!found)
	show_obj_to_char(found_obj, ch, 5);	/* Show no-description */
      else
	show_obj_to_char(found_obj, ch, 6);	/* Find hum, glow etc */
    } else if (!found)
      send_to_char("You do not see that here.\r\n", ch);
  }
}


ACMD(do_look)
{
  static char arg2[MAX_INPUT_LENGTH];
  int look_type, original_loc;
  struct obj_data *obj;

  if (!ch->desc)
    return;

  /* polymorphed object */
  if (CHAR_POLYMORPH_OBJ(ch)) {
    original_loc = ch->in_room;
    obj = CHAR_POLYMORPH_OBJ(ch);
    if (!obj) {
      send_to_char("Something prevents your viewing.\r\n", ch);
      return;
    }
    char_from_room(ch);
    put_char_to_room(ch, obj->in_room, -1, GET_OBJ_X_CORD(obj), GET_OBJ_Y_CORD(obj), GET_OBJ_Z_CORD(obj));
    look_at_room(ch, 1);
    char_from_room(ch);
    char_to_room(ch, original_loc, -1);
    return;
  }
  /* regular code */

  if (GET_STAT(ch) <= STAT_SLEEPING)
    send_to_char("You can't see anything but stars!\r\n", ch);
  else if (IS_AFFECTED(ch, AFF_BLIND))
    send_to_char("You can't see a damned thing, you're blind!\r\n", ch);
  else if (IS_DARK(ch->in_room) && !CAN_SEE_IN_DARK(ch)) {
    send_to_char("Not much can be seen in the darkness.\r\n", ch);
    smallmap_look(ch, view_distance(ch), -1);
    list_char_to_char(world[ch->in_room].people, ch);	/* glowing red eyes */
  } else {
    half_chop(argument, arg, arg2);

    if (subcmd == SCMD_READ) {
      if (!*arg)
	send_to_char("Read what?\r\n", ch);
      else
	look_at_target(ch, arg, 1);
      return;
    }
    if (!*arg)			/* "look" alone, without an argument at all */
      look_at_room(ch, 1);
    else if (is_abbrev(arg, "in"))
      look_in_obj(ch, arg2);
    /* did the char type 'look <direction>?' */
    else if ((look_type = search_block(arg, dirs, FALSE)) >= 0)
      look_in_direction(ch, look_type);
    else if (is_abbrev(arg, "at"))
      look_at_target(ch, arg2, 0);
    else
      look_at_target(ch, arg, 0);
  }
}
ACMD(do_examine)
{
  int bits, found;
  struct char_data *tmp_char;
  struct obj_data *tmp_object;

  one_argument(argument, arg);

  if (!*arg) {
    send_to_char("Examine what?\r\n", ch);
    return;
  }
  look_at_target(ch, arg, 0);

  bits = generic_find(arg, FIND_OBJ_INV | FIND_OBJ_ROOM | FIND_CHAR_ROOM |
		      FIND_OBJ_EQUIP, ch, &tmp_char, &tmp_object);

  if (tmp_object) {
    if ((GET_OBJ_TYPE(tmp_object) == ITEM_DRINKCON) ||
	(GET_OBJ_TYPE(tmp_object) == ITEM_FOUNTAIN) ||
	(GET_OBJ_TYPE(tmp_object) == ITEM_CONTAINER)) {
      send_to_char("When you look inside, you see:\r\n", ch);
      look_in_obj(ch, arg);
    }
  }
  /* Anyone using this furniture? */
  if (tmp_object && tmp_object->people) {
    sprintf(buf, "It is being used as furniture by:");
    for (found = 0, tmp_char = tmp_object->people; tmp_char;
	 tmp_char = tmp_char->next_in_furniture) {
      if (!CAN_SEE(ch, tmp_char))
	continue;
      sprintf(buf2, "%s %s", found++ ? "," : "", GET_NAME(tmp_char));
      strcat(buf, buf2);
      if (strlen(buf) >= 62) {
	if (tmp_char->next_in_furniture)
	  send_to_char(strcat(buf, ",\r\n"), ch);
	else
	  send_to_char(strcat(buf, "\r\n"), ch);
	*buf = found = 0;
      }
    }

    if (*buf)
      send_to_char(strcat(buf, "\r\n"), ch);
  }
}



ACMD(do_money)
{
  int coins[5], total;
  int i;
  struct obj_data *obj, *next_obj;
  extern char *coin_stringv(int amount);
  struct char_data *vict;

  one_argument(argument, buf);

  if (*buf && IS_TRUSTED(ch)) {
    if (!(vict = get_char_vis(ch, buf))) {
      send_to_char("You can't count the cash on someone not here.\r\n", ch);
      return;
    }
  } else
    vict = ch;

  for (i = 0; i < 5; i++)
    coins[i] = 0;
  total = 0;

  for (obj = vict->carrying; obj; obj = next_obj) {
    next_obj = obj->next_content;
    if (CAN_SEE_OBJ(ch, obj)) {
      if (GET_OBJ_TYPE(obj) == ITEM_MONEY) {
	coins[GET_OBJ_VAL(obj, 1)] += GET_OBJ_VAL(obj, 0);
      }
    }
  }

  if (GET_EQ(vict, WEAR_HOLD)) {
    if (CAN_SEE_OBJ(ch, GET_EQ(vict, WEAR_HOLD))) {
      if (GET_OBJ_TYPE(GET_EQ(vict, WEAR_HOLD)) == ITEM_MONEY) {
	coins[GET_OBJ_VAL(GET_EQ(vict, WEAR_HOLD), 1)] += GET_OBJ_VAL(GET_EQ(vict, WEAR_HOLD), 0);
      }
    }
  }
  if (GET_EQ(vict, WEAR_HOLD2)) {
    if (CAN_SEE_OBJ(ch, GET_EQ(vict, WEAR_HOLD2))) {
      if (GET_OBJ_TYPE(GET_EQ(vict, WEAR_HOLD2)) == ITEM_MONEY) {
	coins[GET_OBJ_VAL(GET_EQ(vict, WEAR_HOLD2), 1)] += GET_OBJ_VAL(GET_EQ(vict, WEAR_HOLD2), 0);
      }
    }
  }
  if (GET_EQ(vict, WEAR_ATTACH_1)) {
    obj = GET_EQ(vict, WEAR_ATTACH_1);
    if (obj->contains)
      for (obj = obj->contains; obj; obj = obj->next_content)
	if (CAN_SEE_OBJ(ch, obj) && GET_OBJ_TYPE(obj) == ITEM_MONEY)
	  coins[GET_OBJ_VAL(obj, 1)] += GET_OBJ_VAL(obj, 0);
  }
  if (GET_EQ(vict, WEAR_ATTACH_2)) {
    obj = GET_EQ(vict, WEAR_ATTACH_2);
    if (obj->contains)
      for (obj = obj->contains; obj; obj = obj->next_content)
	if (CAN_SEE_OBJ(ch, obj) && GET_OBJ_TYPE(obj) == ITEM_MONEY)
	  coins[GET_OBJ_VAL(obj, 1)] += GET_OBJ_VAL(obj, 0);
  }
  if (GET_EQ(vict, WEAR_ATTACH_3)) {
    obj = GET_EQ(vict, WEAR_ATTACH_3);
    if (obj->contains)
      for (obj = obj->contains; obj; obj = obj->next_content)
	if (CAN_SEE_OBJ(ch, obj) && GET_OBJ_TYPE(obj) == ITEM_MONEY)
	  coins[GET_OBJ_VAL(obj, 1)] += GET_OBJ_VAL(obj, 0);
  }
  total = ((coins[4] * 10000) + (coins[3] * 1000) + (coins[2] * 100) + (coins[1] * 10) + coins[0]);
  if (total <= 0) {
    send_to_char("You appear to have no money to count.\r\n", ch);
    return;
  }
  sprintf(buf, "You have %d &+WPlatinum&n, %d &+YGold&n, %d &+LElectrum&n, %d Silver, %d &+yCopper&n.\r\n", coins[4], coins[3], coins[2], coins[1], coins[0]);
  sprintf(buf, "%sfor a total of %s.\r\n", buf, coin_stringv(total));
  send_to_char(buf, ch);
}

ACMD(do_score)
{
  struct time_info_data playing_time;
  struct time_info_data real_time_passed(time_t t2, time_t t1);

  strcpy(buf, "");


  if (IS_GREY_TERM(ch->desc)) {
    disp_char_sheet1(ch);
    return;
  }
  if (IS_CLIENT_TERM(ch->desc)) {
    sprintf(buf, "%s", CLIENT_SCORE_PREFIX);
    send_to_char(buf, ch);
  }
  disp_char_sheet(ch);

  if (!IS_NPC(ch)) {
    playing_time = real_time_passed((time(0) - ch->player.time.logon) +
				    ch->player.time.played, 0);
    sprintf(buf, "You have been playing for %d days and %d hours.\r\n",
	    playing_time.day, playing_time.hours);
  }
  if (GET_COND(ch, DRUNK) > 10)
    strcat(buf, "You are intoxicated.\r\n");

  if (GET_COND(ch, FULL) == 0)
    strcat(buf, "You are hungry.\r\n");

  if (GET_COND(ch, THIRST) == 0)
    strcat(buf, "You are thirsty.\r\n");

  if (IS_AFFECTED(ch, AFF_BLIND))
    strcat(buf, "You have been blinded!\r\n");

  if (IS_AFFECTED(ch, AFF_INVISIBLE))
    strcat(buf, "You are invisible.\r\n");

  if (IS_DETECTING(ch, DETECTING_INVIS))
    strcat(buf, "You are sensitive to the presence of invisible things.\r\n");

  if (IS_AFFECTED(ch, AFF_POISON))
    strcat(buf, "You are poisoned!\r\n");

  if (IS_AFFECTED(ch, AFF_CHARM))
    strcat(buf, "You have been charmed!\r\n");

  if (IS_AFFECTED(ch, AFF_INFRAVISION))
    strcat(buf, "Your eyes are glowing red.\r\n");

  send_to_char(buf, ch);
  if (IS_CLIENT_TERM(ch->desc)) {
    sprintf(buf, "%s", CLIENT_SUFFIX);
    send_to_char(buf, ch);
  }
}


ACMD(do_inventory)
{
  send_to_char("You are currently juggling:\r\n", ch);
  list_obj_to_char(ch->carrying, ch, 1, TRUE, FALSE);
}


void equipment1(struct char_data *ch)
{
  int i;

  send_to_char(PLUGIN_EQUIP_START, ch);
  for (i = 0; i < NUM_WEARS; i++) {
    if (GET_EQ(ch, i)) {
      if (CAN_SEE_OBJ(ch, GET_EQ(ch, i))) {
	sprintf(buf, "%s|", strip_color(GET_EQ(ch, i)->short_description));
	send_to_char(buf, ch);
      } else {
	send_to_char("Something|", ch);
      }
    } else {
      send_to_char("|", ch);
    }
  }
  send_to_char(PLUGIN_EQUIP_END, ch);
}


ACMD(do_equipment)
{
  int i, found = 0;

  if (IS_GREY_TERM(ch->desc)) {
    equipment1(ch);
    return;
  }
  if (IS_CLIENT_TERM(ch->desc)) {
    sprintf(buf, "%s", CLIENT_EQUIP_PREFIX);
    send_to_char(buf, ch);
  }
  send_to_char("You are using:\r\n", ch);
  for (i = 0; i < NUM_WEARS; i++) {
    if (GET_EQ(ch, i)) {
      if (CAN_SEE_OBJ(ch, GET_EQ(ch, i))) {
	send_to_char(where[i], ch);
	show_obj_to_char(GET_EQ(ch, i), ch, 1);
	found = TRUE;
	if (IS_CONTAINER(GET_EQ(ch, i))) {
	  if (GET_EQ(ch, i)->contains)
	    list_obj_to_char(GET_EQ(ch, i)->contains, ch, 8, TRUE, FALSE);
	  else
	    send_to_char("    <&+Lcontains&n>   Empty.\r\n", ch);
	}
      } else {
	send_to_char(where[i], ch);
	send_to_char("Something.\r\n", ch);
	found = TRUE;
      }
    }
  }
  if (!found) {
    send_to_char(" Nothing.\r\n", ch);
  }
  if (IS_CLIENT_TERM(ch->desc)) {
    sprintf(buf, "%s", CLIENT_SUFFIX);
    send_to_char(buf, ch);
  }
}


ACMD(do_time)
{
  char *suf, ditty[20];
  int weekday, day;
  extern struct time_info_data time_info;
  extern char *weekdays[];
  extern char *month_name[];

  ditty[0] = '\0';

  if (time_info.minutes == 0) {
    sprintf(ditty, " 'O clock");
  } else {
    sprintf(ditty, ":%s%d", (time_info.minutes >= 10) ? "" : "0",
	    time_info.minutes);
  }

  sprintf(buf, "It is %d%s %s, on ",
	  ((time_info.hours % 12 == 0) ? 12 : ((time_info.hours) % 12)),
	  ditty, ((time_info.hours >= 12) ? "pm" : "am"));

  /* 28 days in a month */
  weekday = ((28 * time_info.month) + time_info.day + 1) % 7;

  strcat(buf, weekdays[weekday]);
  strcat(buf, "\r\n");

  send_to_char(buf, ch);

  day = time_info.day + 1;	/* day in [1..28] */

  if (day == 1)
    suf = "st";
  else if (day == 2)
    suf = "nd";
  else if (day == 3)
    suf = "rd";
  else if (day < 20)
    suf = "th";
  else if ((day % 10) == 1)
    suf = "st";
  else if ((day % 10) == 2)
    suf = "nd";
  else if ((day % 10) == 3)
    suf = "rd";
  else
    suf = "th";

  sprintf(buf, "The %d%s Day of the %s, Year %d CY.\r\n",
	  day, suf, month_name[(int) time_info.month], time_info.year);

  send_to_char(buf, ch);
}


ACMD(do_help)
{
  int chk, bot, top, mid, minlen;

  if (!ch->desc)
    return;

  skip_spaces(&argument);

  if (!*argument) {
    send_to_char(help, ch);
    sprintf(buf, "\r\nWith a total of %d entries....\r\n", top_of_helpt);
    send_to_char(buf, ch);
    return;
  }
  if (!help_table) {
    send_to_char("No help available.\r\n", ch);
    return;
  }
  bot = 0;
  top = top_of_helpt;
  minlen = strlen(argument);

  for (;;) {
    mid = (bot + top) / 2;

    if (bot > top) {
      send_to_char("!!SOUND(nohelp* T=general)There is no help on that word.\r\n", ch);
      return;
    } else if (!(chk = strn_cmp(argument, help_table[mid].keyword, minlen))) {
      /* trace backwards to find first matching entry. Thanks Jeff Fink! */
      while ((mid > 0) &&
      (!(chk = strn_cmp(argument, help_table[mid - 1].keyword, minlen))))
	mid--;
      page_string(ch->desc, help_table[mid].entry, 0);
      return;
    } else {
      if (chk > 0)
	bot = mid + 1;
      else
	top = mid - 1;
    }
  }
}


/*********************************************************************
* New 'do_who' by Daniel Koepke [aka., "Argyle Macleod"] of The Keep *
******************************************************************* */

char *WHO_USAGE =
"Usage: who [minlev[-maxlev]] [-n name] [-c classes] [-rzqimo]\r\n"
"\r\n"
"Classes: (M)age, (C)leric, (T)hief, (W)arrior\r\n"
"\r\n"
" Switches: \r\n"
"_.,-'^'-,._\r\n"
"\r\n"
"  -r = who is in the current room\r\n"
"  -z = who is in the current zone\r\n"
"\r\n"
"  -g = only show immortals\r\n"
"  -m = only show mortals\r\n"
"\r\n";

ACMD(do_who)
{
  struct descriptor_data *d;
  struct char_data *wch;
  char Imm_buf[MAX_STRING_LENGTH];
  char Mort_buf[MAX_STRING_LENGTH];
  char name_search[MAX_NAME_LENGTH + 1];
  char mode;

  int low = 0, high = LVL_IMPL, showclass = 0, x, nonstandard = FALSE;
  bool who_room = FALSE, who_zone = FALSE;
  bool noimm = FALSE, nomort = FALSE;

  int Wizards = 0, Mortals = 0;
  size_t i;

  const char *WizLevels[LVL_IMPL - (LVL_IMMORT - 1)] =
  {
    "     &+GGuest&n    ",
    "    &+CTrainee&n   ",
    "&+LLesser&+B Builder&n",
    " &+LLesser&+R Coder&n ",
    "&+LGreater&+BBuilder&n",
    " &+LGreater&+RCoder&n ",
    "&+LSenior&+B Builder&n",
    " &+LSenior&+L Coder&n ",
    "  &+LAssistantDM&n ",
    "&+LDungeon Master&n"
  };

  skip_spaces(&argument);
  strcpy(buf, argument);
  name_search[0] = '\0';

  /* the below is from stock CircleMUD -- found no reason to rewrite it */
  while (*buf) {
    half_chop(buf, arg, buf1);
    if (isdigit(*arg)) {
      sscanf(arg, "%d-%d", &low, &high);
      strcpy(buf, buf1);
    } else if (*arg == '-') {
      nonstandard = TRUE;
      mode = *(arg + 1);	/* just in case; we destroy arg in the switch */
      switch (mode) {
      case 'z':
	who_zone = TRUE;
	strcpy(buf, buf1);
	break;
      case 'l':
	half_chop(buf1, arg, buf);
	sscanf(arg, "%d-%d", &low, &high);
	break;
      case 'n':
	half_chop(buf1, name_search, buf);
	break;
      case 'r':
	who_room = TRUE;
	strcpy(buf, buf1);
	break;
      case 'c':
	half_chop(buf1, arg, buf);
	for (i = 0; i < strlen(arg); i++)
	  showclass |= find_class_bitvector(arg[i]);
	break;
      case 'i':
      case 'g':
	nomort = TRUE;
	strcpy(buf, buf1);
	break;
      case 'm':
	nonstandard = FALSE;
	noimm = TRUE;
	strcpy(buf, buf1);
	break;
      default:
	send_to_char(WHO_USAGE, ch);
	return;
	break;
      }				/* end of switch */

    } else {			/* endif */
      half_chop(arg, name_search, buf);
      nonstandard = TRUE;
    }
  }				/* end while (parser) */

  strcpy(Imm_buf, "&+B     Creators currently online\r\n&+B=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r\n&n");
  strcpy(Mort_buf, "&+c   Players currently online\r\n&+c=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r\n&n");

  for (d = descriptor_list; d; d = d->next) {
    if (d->connected && !(d->connected >= CON_OEDIT && d->connected <= CON_TEDIT))
      continue;

    if (d->connected == CON_PEDIT)
      continue;

    if (d->original)
      wch = d->original;
    else if (!(wch = d->character))
      continue;

    if (!CAN_SEE_WHO(ch, wch))
      continue;
    if (GET_LEVEL(wch) < low || GET_LEVEL(wch) > high)
      continue;
    if ((noimm && GET_LEVEL(wch) >= LVL_IMMORT) || (nomort && GET_LEVEL(wch) < LVL_IMMORT))
      continue;
    if (*name_search && str_cmp(GET_NAME(wch), name_search) && !strstr(GET_TITLE(wch), name_search))
      continue;
    if (who_zone && world[ch->in_room].zone != world[wch->in_room].zone)
      continue;
    if (who_room && (wch->in_room != ch->in_room))
      continue;
    if (showclass && !(showclass & (1 << GET_CLASS(wch))))
      continue;

    if (GET_LEVEL(wch) >= LVL_IMMORT) {
      sprintf(Imm_buf, "%s[%s] %s %s", Imm_buf,
	      WizLevels[GET_LEVEL(wch) - LVL_IMMORT], GET_NAME(wch),
	      GET_TITLE(wch));

      Wizards++;
    } else {
      sprintf(Mort_buf, "%s[&+w%2d %s&N] %s %s &n(%s&n)", Mort_buf, GET_LEVEL(wch),
	      class_names[(int) GET_CLASS(wch)], GET_NAME(wch), GET_TITLE(wch), race_names[(int) GET_RACE(wch)]);
      Mortals++;
    }

    *buf = '\0';

    if (GET_INVIS_LEV(wch))
      sprintf(buf, "&+b(vis%d)&n", GET_INVIS_LEV(wch));
    else if (IS_AFFECTED(wch, AFF_INVISIBLE))
      strcat(buf, " (invis)");

    if (PLR_FLAGGED(wch, PLR_MAILING))
      strcat(buf, " (mailing)");
    else if (PLR_FLAGGED(wch, PLR_WRITING))
      strcat(buf, " (writing)");

    if (d->connected == CON_OEDIT)
      sprintf(buf + strlen(buf), "(OEDIT %d)", OLC_NUM(d));
    else if (d->connected == CON_REDIT)
      sprintf(buf + strlen(buf), "(REDIT %d)", OLC_NUM(d));
    else if (d->connected == CON_ZEDIT)
      sprintf(buf + strlen(buf), "(ZEDIT %d)", OLC_NUM(d));
    else if (d->connected == CON_MEDIT)
      sprintf(buf + strlen(buf), "(MEDIT %d)", OLC_NUM(d));
    else if (d->connected == CON_SEDIT)
      sprintf(buf + strlen(buf), "(SEDIT %d)", OLC_NUM(d));
    else if (d->connected == CON_GEDIT)
      strcat(buf, "(GEDIT)");
    else if (d->connected == CON_QEDIT)
      strcat(buf, "(QEDIT)");
    else if (d->connected == CON_HEDIT)
      strcat(buf, "(HEDIT)");
    else if (d->connected == CON_PEDIT)
      strcat(buf, "(PEDIT)");
    else if (d->connected == CON_AEDIT)
      strcat(buf, "(AEDIT)");
    else if (d->connected == CON_TEDIT)
      strcat(buf, "(TEDIT)");

    if (PRF_FLAGGED(wch, PRF_DEAF))
      strcat(buf, " (deaf)");
    if (PRF_FLAGGED(wch, PRF_NOTELL))
      strcat(buf, " (notell)");

    if (world[wch->in_room].number <= 0)
      strcat(buf, " (&+Lvoided&n)");

    strcat(buf, "\r\n");

    if (GET_LEVEL(wch) >= LVL_IMMORT)
      strcat(Imm_buf, buf);
    else
      strcat(Mort_buf, buf);

  }				/* end of for */
#if 0
  /* Fake a few players here, just temp to help us get started */
  if (!nonstandard)
    for (x = 0; x < num_fake_chars; x++) {
      sprintf(buf, "[&+w%2d %s&N] %s &n(%s&n)\r\n",
	      fake_char_info[x][2],
	      class_names[(int) fake_char_info[x][1]],
	      fake_char_names[x],
	      race_names[(int) fake_char_info[x][0]]);
      strcat(Mort_buf, buf);
      Mortals++;
    }
  /* End of fake addition */
#endif

  if ((Wizards + Mortals) > boot_high)
    boot_high = Wizards + Mortals;
  sprintf(buf2, "%sThere is a boot time high of %d player%s.\r\n", buf, boot_high, (boot_high == 1 ? "" : "s"));
  strcat(Mort_buf, buf2);

  if (Wizards) {
/*    page_string(ch->desc, Imm_buf, 0);  Paging loses some info */
    send_to_char(Imm_buf, ch);
    send_to_char("\r\n", ch);
  }
  if (Mortals) {
/*    page_string(ch->desc, Mort_buf, 0); */
    send_to_char(Mort_buf, ch);
    send_to_char("\r\n", ch);
  }
  if ((Wizards + Mortals) == 0)
    strcpy(buf2, "No-one at all is currently visible to you.\r\n");
  if (Wizards)
    sprintf(buf2, "&+BThere %s %d visible creator%s%s&n", (Wizards == 1 ? "is" : "are"), Wizards, (Wizards == 1 ? "" : "s"), (Mortals ? " and there " : "."));
  if (Mortals)
    sprintf(buf2, "&+c%s %s %d visible player%s.&n", (Wizards ? buf : "There"), (Mortals == 1 ? "is" : "are"), Mortals, (Mortals == 1 ? "" : "s"));
  strcat(buf, "\r\n");

}

#if 1
#define USERS_FORMAT \
"format: users [-l minlevel[-maxlevel]] [-n name] [-h host] [-c classlist] [-o] [-p]\r\n"

ACMD(do_users)
{
  extern char *connected_types[];
  char line[200], line2[220], idletime[10], classname[20];
  char state[30], *timeptr, *format, mode;
  char name_search[MAX_INPUT_LENGTH], host_search[MAX_INPUT_LENGTH];
  struct char_data *tch;
  struct descriptor_data *d;
  size_t i;
  int low = 0, high = LVL_IMPL, num_can_see = 0;
  int showclass = 0, playing = 0, deadweight = 0;

  host_search[0] = name_search[0] = '\0';

  strcpy(buf, argument);
  while (*buf) {
    half_chop(buf, arg, buf1);
    if (*arg == '-') {
      mode = *(arg + 1);	/* just in case; we destroy arg in the switch */
      switch (mode) {
      case 'p':
	playing = 1;
	strcpy(buf, buf1);
	break;
      case 'd':
	deadweight = 1;
	strcpy(buf, buf1);
	break;
      case 'l':
	playing = 1;
	half_chop(buf1, arg, buf);
	sscanf(arg, "%d-%d", &low, &high);
	break;
      case 'n':
	playing = 1;
	half_chop(buf1, name_search, buf);
	break;
      case 'h':
	playing = 1;
	half_chop(buf1, host_search, buf);
	break;
      case 'c':
	playing = 1;
	half_chop(buf1, arg, buf);
	for (i = 0; i < strlen(arg); i++)
	  showclass |= find_class_bitvector(arg[i]);
	break;
      default:
	send_to_char(USERS_FORMAT, ch);
	return;
	break;
      }				/* end of switch */

    } else {			/* endif */
      send_to_char(USERS_FORMAT, ch);
      return;
    }
  }				/* end while (parser) */
  strcpy(line,
       "Num Class    Name         State          Idl Login@   Site\r\n");
  strcat(line,
	 "--- -------- ------------ -------------- --- -------- ------------------------\r\n");
  send_to_char(line, ch);

  one_argument(argument, arg);

  for (d = descriptor_list; d; d = d->next) {
    if (d->connected && playing)
      continue;
    if (!d->connected && deadweight)
      continue;
    if (!d->connected) {
      if (d->original)
	tch = d->original;
      else if (!(tch = d->character))
	continue;

      if (*host_search && !strstr(d->host, host_search))
	continue;
      if (*name_search && str_cmp(GET_NAME(tch), name_search))
	continue;
      if (!CAN_SEE(ch, tch) || GET_LEVEL(tch) < low || GET_LEVEL(tch) > high)
	continue;
      if (showclass && !(showclass & (1 << GET_CLASS(tch))))
	continue;
      if (GET_INVIS_LEV(ch) > GET_LEVEL(ch))
	continue;

      if (d->original)
	sprintf(classname, "[%2d %s]", GET_LEVEL(d->original),
		CLASS_ABBR(d->original));
      else
	sprintf(classname, "[%2d %s]", GET_LEVEL(d->character),
		CLASS_ABBR(d->character));
    } else
      strcpy(classname, "   -   ");

    timeptr = asctime(localtime(&d->login_time));
    timeptr += 11;
    *(timeptr + 8) = '\0';

    if (!d->connected && d->original)
      strcpy(state, "Switched");
    else
      strcpy(state, connected_types[d->connected]);

    if (d->character && !d->connected && IS_TRUSTED(d->character))
#if 1
      // this one seems wrong.. but perhaps its not?
      sprintf(idletime, "%3d", d->character->char_specials.timer *
	      SECS_PER_MUD_HOUR / SECS_PER_REAL_MIN);
#else
      sprintf(idletime, "%3d", d->idle_tics *
	      SECS_PER_MUD_HOUR / SECS_PER_REAL_MIN);
#endif
    else
      strcpy(idletime, "");

    format = "%3d %-7s %-12s %-14s %-3s %-8s ";

    if (d->character && d->character->player.name) {
      if (d->original)
	sprintf(line, format, d->desc_num, classname,
		d->original->player.name, state, idletime, timeptr);
      else
	sprintf(line, format, d->desc_num, classname,
		d->character->player.name, state, idletime, timeptr);
    } else
      sprintf(line, format, d->desc_num, "   -   ", "UNDEFINED",
	      state, idletime, timeptr);

    if (d->host && *d->host)
      sprintf(line + strlen(line), "[%s]\r\n", d->host);
    else
      strcat(line, "[Hostname unknown]\r\n");

    if (d->connected) {
      sprintf(line2, "&+b%s&n", line);
      strcpy(line, line2);
    }
    if (d->connected || (!d->connected && CAN_SEE(ch, d->character))) {
      send_to_char(line, ch);
      num_can_see++;
    }
  }

  sprintf(line, "\r\n%d visible sockets connected.\r\n", num_can_see);
  send_to_char(line, ch);
}
#else
ACMD(do_users)
{
  char biglist[MAX_STRING_LENGTH], buf[MAX_STRING_LENGTH];
  char buf2[MAX_INPUT_LENGTH], line[MAX_INPUT_LENGTH], name[MAX_INPUT_LENGTH];
  int num_link_dead = 0, num_in_game = 0, num_non_play = 0, b_len = 160;
  long timer = 0;
  struct char_data *t_ch;
  struct descriptor_data *d = NULL;

  biglist[0] = '\0';

  half_chop(argument, name, line);

  strcpy(biglist, "&+RNon-playing sockets:\r\n--------------------\r\n");

  for (d = descriptor_list; d; d = d->next) {
    if (d->character)
      t_ch = d->character;
    else
      t_ch = NULL;

    if (!d->connected)		/* want non-playing sockets only */
      continue;

    if (t_ch && (GET_LEVEL(t_ch) > GET_LEVEL(ch)))
      continue;			/* hide status on higher levels */

    if (*name)
      if ((!t_ch || !t_ch->player.name || !isname(t_ch->player.name, name)) &&
	  (!d->host || !strstr(d->host, name)))
	continue;

    num_non_play++;

    sprintf(line, "%3d I:%3d", d->descriptor, d->wait / 240);

    if (t_ch && t_ch->player.name)
      sprintf(line + strlen(line), "     %-15s", GET_NAME(t_ch));
    else
      strcat(line, "     &+mNONE&n           ");

    sprinttype(d->connected, connected_types, buf2);
    sprintf(line + strlen(line), "  %11s", buf2);

    /* Get IP Address */
    if (d->host) {
      if (GET_LEVEL(ch) > 50) {
	sprintf(line + strlen(line), "         %s", d->host);
      }
    } else {
      sprintf(line + strlen(line), " &+CUNKNOWN&n        ");
    }

    strcat(line, "\r\n");
    b_len += strlen(line);
    if (b_len > MAX_STRING_LENGTH) {
      strcat(biglist, "List too long, use 'users <arg>'\r\n");
      page_string(ch->desc, biglist, 1);
      return;
    }
    strcat(biglist, line);
  }

  strcat(biglist, "\r\n&+GCharacters:\r\n-----------\r\n");

  b_len = strlen(biglist) + 160;

  for (t_ch = character_list; t_ch; t_ch = t_ch->next) {
    /*
     * handle switched and shapechanged using NPC body, since that's
     * where the desc will be.
     */
    if (IS_NPC(t_ch) && !t_ch->desc)
      continue;

    /* don't list switched chars real bodies */
    if (IS_PC(t_ch) && t_ch->switched)
      continue;

    if (t_ch->desc)
      d = t_ch->desc;
    else
      d = NULL;

    /*
     * minor prob with shapechange, there is no difference between a
     * link dead char, and one that is shapechanged.  So, all linkdead
     * bodies in room 0 (Void), where shapechangers real bodies are
     * stored, do not show up on this list.  JAB
     */

    if (!d && (t_ch->in_room == 0))
      continue;

    if (IS_PC(t_ch) && t_ch->player.name && /*GET_LEVEL(ch) >= GET_INVIS_LEV(t_ch) */ )
      continue;

    if (*name)
      if ((!t_ch->player.name || !isname(t_ch->player.name, name)) &&
	  (!d || !d->host || !strstr(d->host, name)))
	continue;

    if (d && d->original)
      strcpy(line, " S ");
    else
      strcpy(line, "   ");

    if (t_ch->player.name)
      sprintf(line + strlen(line), "%-15s",
	      (d && d->original) ? (d->original->player.name) : (t_ch->player.name));
    else
      strcpy(line, "&+RUNDEFINED&n          ");

    timer = t_ch->desc->idle_tics;

    if (t_ch->in_room > NOWHERE)
      sprintf(line + strlen(line), " [%6d] ", world[t_ch->in_room].number);
    else
      strcat(line, "  ??????  ");

    if (d && d->original && IS_PC(d->original) && (GET_INVIS_LEV(d->original) != 0))
      sprintf(line + strlen(line), "%2d ", GET_INVIS_LEV(d->original));
    else if (IS_PC(t_ch) && (GET_INVIS_LEV(t_ch) != 0))
      sprintf(line + strlen(line), "%2d ", GET_INVIS_LEV(t_ch));
    else
      strcat(line, "   ");

    if (d) {
      num_in_game++;

      /* Get IP Address */
      if (d->host) {
	if (GET_LEVEL(ch) > 50) {
	  sprintf(line + strlen(line), "         %s", d->host);
	}
      } else {
	sprintf(line + strlen(line), " &+CUNKNOWN&n        ");
      }
    } else {
      num_link_dead++;
      strcat(line, " &+BLINK DEAD&n       ");
    }
#if 0
    if (d && d->snoop.snoop_by_list && (GET_LEVEL(ch) >= 62)) {
      snoop_by_ptr = d->snoop.snoop_by_list;

      sprintf(line + strlen(line), " &+g(S: %s",
	      GET_NAME(snoop_by_ptr->snoop_by));

      snoop_by_ptr = snoop_by_ptr->next;
      while (snoop_by_ptr) {
	sprintf(line + strlen(line), ", %s", GET_NAME(snoop_by_ptr->snoop_by));

	snoop_by_ptr = snoop_by_ptr->next;
      }

      strcat(line, ")&n");
    }
#endif
    strcat(line, "\r\n");
    if (d)
      sprintf(buf, "%3d I:%3ld  ", d->descriptor, timer);
    else
      sprintf(buf, "&+B---&n I:%3ld  ", timer);

    strcat(buf, line);
    b_len += strlen(buf);
    if (b_len > MAX_STRING_LENGTH) {
      strcat(biglist, "List too long, use 'users <arg>'\r\n");
      page_string(ch->desc, biglist, 1);
      return;
    }
    strcat(biglist, buf);
  }

  sprintf(line, "\r\nNon-playing: %d  In game: %d  Linkdeads: %d  Sockets: %d\r\n",
  num_non_play, num_in_game, num_link_dead, (num_non_play + num_in_game));
  strcat(biglist, line);

  page_string(ch->desc, biglist, 1);
}
#endif

/* Generic page_string function for displaying text */
ACMD(do_gen_ps)
{
  switch (subcmd) {
  case SCMD_CREDITS:
    page_string(ch->desc, credits, 0);
    break;
  case SCMD_NEWS:
    page_string(ch->desc, news, 0);
    break;
  case SCMD_INFO:
    page_string(ch->desc, info, 0);
    break;
  case SCMD_WIZLIST:
    page_string(ch->desc, wizlist, 0);
    break;
  case SCMD_IMMLIST:
    page_string(ch->desc, immlist, 0);
    break;
  case SCMD_HANDBOOK:
    page_string(ch->desc, handbook, 0);
    break;
  case SCMD_POLICIES:
    page_string(ch->desc, policies, 0);
    break;
  case SCMD_MOTD:
    page_string(ch->desc, motd, 0);
    break;
  case SCMD_IMOTD:
    page_string(ch->desc, imotd, 0);
    break;
  case SCMD_CLEAR:
    send_to_char("\033[H\033[J", ch);
    break;
  case SCMD_WHOAMI:
    send_to_char(strcat(strcpy(buf, GET_NAME(ch)), "\r\n"), ch);
    break;
  default:
    return;
    break;
  }
}


void perform_mortal_where(struct char_data *ch, char *arg)
{
  register struct char_data *i;
  register struct descriptor_data *d;

  if (!*arg) {
    send_to_char("Players in your Zone\r\n--------------------\r\n", ch);
    for (d = descriptor_list; d; d = d->next)
      if (!d->connected) {
	i = (d->original ? d->original : d->character);
	if (i && CAN_SEE(ch, i) && (i->in_room != NOWHERE) &&
	    (world[ch->in_room].zone == world[i->in_room].zone)) {
	  sprintf(buf, "%-20s - %s\r\n", GET_NAME(i), world[i->in_room].name);
	  send_to_char(buf, ch);
	}
      }
  } else {			/* print only FIRST char, not all. */
    for (i = character_list; i; i = i->next)
      if (world[i->in_room].zone == world[ch->in_room].zone && CAN_SEE(ch, i) &&
	  (i->in_room != NOWHERE) && isname(arg, i->player.name)) {
	sprintf(buf, "%-25s - %s\r\n", GET_NAME(i), world[i->in_room].name);
	send_to_char(buf, ch);
	return;
      }
    send_to_char("No-one around by that name.\r\n", ch);
  }
}


void print_object_location(int num, struct obj_data *obj, struct char_data *ch,
			   int recur)
{
  if (num > 0)
    sprintf(buf, "O%3d. %-25s - ", num, obj->short_description);
  else
    sprintf(buf, "%33s", " - ");

  if (obj->in_room > NOWHERE) {
    sprintf(buf + strlen(buf), "[%5d] %s\n\r",
	    world[obj->in_room].number, world[obj->in_room].name);
    send_to_char(buf, ch);
  } else if (obj->carried_by) {
    sprintf(buf + strlen(buf), "carried by %s\n\r",
	    PERS(obj->carried_by, ch, TRUE));
    send_to_char(buf, ch);
  } else if (obj->worn_by) {
    sprintf(buf + strlen(buf), "worn by %s\n\r",
	    PERS(obj->worn_by, ch, TRUE));
    send_to_char(buf, ch);
  } else if (obj->in_obj) {
    sprintf(buf + strlen(buf), "inside %s%s\n\r",
	    obj->in_obj->short_description, (recur ? ", which is" : " "));
    send_to_char(buf, ch);
    if (recur)
      print_object_location(0, obj->in_obj, ch, recur);
  } else {
    sprintf(buf + strlen(buf), "in an unknown location\n\r");
    send_to_char(buf, ch);
  }
}



void perform_immort_where(struct char_data *ch, char *arg)
{
  register struct char_data *i;
  register struct obj_data *k;
  struct descriptor_data *d;
  int num = 0, found = 0, counter = 0;

  if (!*arg) {
    send_to_char("Players\r\n-------\r\n", ch);
    for (d = descriptor_list; d && counter < 100; d = d->next)
      if (!d->connected) {
	i = (d->original ? d->original : d->character);
	if (i && CAN_SEE(ch, i) && (i->in_room != NOWHERE)) {
	  if (d->original)
	    sprintf(buf, "%-20s - [%5d] %s (in %s)\r\n",
		    GET_NAME(i), world[d->character->in_room].number,
	      world[d->character->in_room].name, GET_NAME(d->character));
	  else
	    sprintf(buf, "%-20s - [%5d] %s\r\n", GET_NAME(i),
		    world[i->in_room].number, world[i->in_room].name);
	  send_to_char(buf, ch);
	  counter++;
	}
      }
  } else if (isdigit(*arg)) {
    for (i = character_list; i && counter < 100; i = i->next)
      if (CAN_SEE(ch, i) && i->in_room != NOWHERE &&
	  IS_NPC(i) && GET_MOB_VNUM(i) == atoi(arg)) {
	found = 1;
	sprintf(buf, "M%3d. %-20s - [%5d](%2d %2d %2d) %s\r\n", ++num, GET_NAME(i),
		world[i->in_room].number, GET_X_CORD(i), GET_Y_CORD(i), GET_Z_CORD(i), world[i->in_room].name);
	send_to_char(buf, ch);
	counter++;
      }
    for (num = 0, k = object_list; k && counter < 100; k = k->next)
      if (CAN_SEE_OBJ(ch, k) && GET_OBJ_VNUM(k) == atoi(arg) &&
	  (!k->carried_by || CAN_SEE(ch, k->carried_by))) {
	found = 1;
	print_object_location(++num, k, ch, TRUE);
	counter++;
      }
    if (!found)
      send_to_char("Couldn't find any such thing.\r\n", ch);
  } else {
    for (i = character_list; i && counter < 100; i = i->next)
      if (CAN_SEE(ch, i) && i->in_room != NOWHERE && isname(arg, i->player.name)) {
	found = 1;
	sprintf(buf, "M%3d. %-20s - [%5d](%2d %2d %2d) %s\r\n", ++num, GET_NAME(i),
		world[i->in_room].number, GET_X_CORD(i), GET_Y_CORD(i), GET_Z_CORD(i), world[i->in_room].name);
	send_to_char(buf, ch);
	counter++;
      }
    for (num = 0, k = object_list; k && counter < 100; k = k->next)
      if (CAN_SEE_OBJ(ch, k) && isname(arg, k->name) &&
	  (!k->carried_by || CAN_SEE(ch, k->carried_by))) {
	found = 1;
	print_object_location(++num, k, ch, TRUE);
	counter++;
      }
    if (!found)
      send_to_char("Couldn't find any such thing.\r\n", ch);
  }
  if (counter >= 99)
    send_to_char("And the list goes on....\r\n", ch);
}



ACMD(do_where)
{
  one_argument(argument, arg);

  if (IS_TRUSTED(ch))
    perform_immort_where(ch, arg);
  else
    perform_mortal_where(ch, arg);
}



ACMD(do_levels)
{
  int i;

  if (IS_NPC(ch)) {
    send_to_char("You ain't nothin' but a hound-dog.\r\n", ch);
    return;
  }
  *buf = '\0';

  for (i = 1; i < LVL_IMMORT; i++) {
    sprintf(buf + strlen(buf), "[%2d] %8d-%-8d : ", i,
       level_exp(GET_CLASS(ch), i), level_exp(GET_CLASS(ch), i + 1) - 1);
    strcat(buf, "\r\n");
  }
  sprintf(buf + strlen(buf), "[%2d] %8d          : Immortality\r\n",
	  LVL_IMMORT, level_exp(GET_CLASS(ch), LVL_IMMORT));
  page_string(ch->desc, buf, 1);
}



ACMD(do_consider)
{
  struct char_data *victim;
  int diff;

  one_argument(argument, buf);

  if (!(victim = get_char_room_vis(ch, buf))) {
    send_to_char("Consider killing who?\r\n", ch);
    return;
  }
  if (victim == ch) {
    send_to_char("Easy!  Very easy indeed!\r\n", ch);
    return;
  }
  if (!IS_NPC(victim)) {
    send_to_char("Would you like to borrow a cross and a shovel?\r\n", ch);
    return;
  }
  diff = (GET_LEVEL(victim) - GET_LEVEL(ch));

  if (diff <= -10)
    send_to_char("Now where did that chicken go?\r\n", ch);
  else if (diff <= -5)
    send_to_char("You could do it with a needle!\r\n", ch);
  else if (diff <= -2)
    send_to_char("Easy.\r\n", ch);
  else if (diff <= -1)
    send_to_char("Fairly easy.\r\n", ch);
  else if (diff == 0)
    send_to_char("The perfect match!\r\n", ch);
  else if (diff <= 1)
    send_to_char("You would need some luck!\r\n", ch);
  else if (diff <= 2)
    send_to_char("You would need a lot of luck!\r\n", ch);
  else if (diff <= 3)
    send_to_char("You would need a lot of luck and great equipment!\r\n", ch);
  else if (diff <= 5)
    send_to_char("Do you feel lucky, punk?\r\n", ch);
  else if (diff <= 10)
    send_to_char("Are you mad!?\r\n", ch);
  else if (diff <= 100)
    send_to_char("You ARE mad!\r\n", ch);

}



ACMD(do_diagnose)
{
  struct char_data *vict;

  one_argument(argument, buf);

  if (*buf) {
    if (!(vict = get_char_room_vis(ch, buf))) {
      send_to_char(NOPERSON, ch);
      return;
    } else
      diag_char_to_char(vict, ch);
  } else {
    if (FIGHTING(ch))
      diag_char_to_char(FIGHTING(ch), ch);
    else if (subcmd != SCMD_GLANCE)
      send_to_char("Diagnose who?\r\n", ch);
    else
      send_to_char("Glance at whom?\r\n", ch);
  }
}


ACMD(do_toggle)
{
  if (IS_NPC(ch))
    return;
  if (GET_WIMP_LEV(ch) == 0)
    strcpy(buf2, "OFF");
  else
    sprintf(buf2, "%-3d", GET_WIMP_LEV(ch));

  sprintf(buf,
	  "   Compact Mode: %-3s    "
	  "         NoTell: %-3s    "
	  "   Repeat Comm.: %-3s\r\n"

	  "           Deaf: %-3s    "
#ifdef MUDFTP
	  "         mudFTP: %-3s    "
#endif
	  "     Wimp Level: %-3s\r\n"
	  "         Paging: %-3s    "
	  "           Turn: %-3s\r\n",

	  ONOFF(PRF_FLAGGED(ch, PRF_COMPACT)),
	  ONOFF(PRF_FLAGGED(ch, PRF_NOTELL)),
	  YESNO(!PRF_FLAGGED(ch, PRF_NOREPEAT)),

	  YESNO(PRF_FLAGGED(ch, PRF_DEAF)),
#ifdef MUDFTP
	  YESNO(PRF_FLAGGED(ch, PRF_MUDFTP)),
#endif
	  buf2,
	  ONOFF(PRF_FLAGGED(ch, PRF_PAGING)),
	  YESNO(PRF_FLAGGED(ch, PRF_TURN)));


  send_to_char(buf, ch);
}


struct sort_struct {
  int sort_pos;
  byte is_social;
} *cmd_sort_info = NULL;

int num_of_cmds;


void sort_commands(void)
{
  int a, b, tmp;

  ACMD(do_action);

  num_of_cmds = 0;

  /*
   * first, count commands (num_of_commands is actually one greater than the
   * number of commands; it inclues the '\n'.
   */
  while (*complete_cmd_info[num_of_cmds].command != '\n')
    num_of_cmds++;

  /* check if there was an old sort info.. then free it -- aedit -- M. Scott */
  if (cmd_sort_info)
    FREE(cmd_sort_info);

  /* create data array */
  CREATE(cmd_sort_info, struct sort_struct, num_of_cmds);

  /* initialize it */
  for (a = 1; a < num_of_cmds; a++) {
    cmd_sort_info[a].sort_pos = a;
    cmd_sort_info[a].is_social = (complete_cmd_info[a].command_pointer == do_action);
  }				/* Sort.  'a' starts at 1, not 0, to remove 'RESERVED' */
  for (a = 1; a < num_of_cmds - 1; a++)
    for (b = a + 1; b < num_of_cmds; b++)
      if (strcmp(complete_cmd_info[cmd_sort_info[a].sort_pos].command,
	     complete_cmd_info[cmd_sort_info[b].sort_pos].command) > 0) {
	tmp = cmd_sort_info[a].sort_pos;
	cmd_sort_info[a].sort_pos = cmd_sort_info[b].sort_pos;
	cmd_sort_info[b].sort_pos = tmp;
      }
}



ACMD(do_commands)
{
  int no, i, cmd_num;
  int wizhelp = 0, socials = 0;
  struct char_data *vict;

  one_argument(argument, arg);

  if (*arg) {
    if (!(vict = get_char_vis(ch, arg)) || IS_NPC(vict)) {
      send_to_char("Who is that?\r\n", ch);
      return;
    }
    if (GET_LEVEL(ch) < GET_LEVEL(vict)) {
      send_to_char("You can't see the commands of people above your level.\r\n", ch);
      return;
    }
  } else
    vict = ch;

  if (subcmd == SCMD_SOCIALS)
    socials = 1;
  else if (subcmd == SCMD_WIZHELP)
    wizhelp = 1;

  sprintf(buf, "The following %s%s are available to %s:\r\n",
	  wizhelp ? "privileged " : "",
	  socials ? "socials" : "commands",
	  vict == ch ? "you" : GET_NAME(vict));

  /* cmd_num starts at 1, not 0, to remove 'RESERVED' */
  for (no = 1, cmd_num = 1; cmd_num < num_of_cmds; cmd_num++) {
    i = cmd_sort_info[cmd_num].sort_pos;
    if (complete_cmd_info[i].minimum_level >= 0 &&
	GET_LEVEL(vict) >= complete_cmd_info[i].minimum_level &&
	(complete_cmd_info[i].minimum_level >= LVL_IMMORT) == wizhelp &&
	(wizhelp || socials == cmd_sort_info[i].is_social)) {
      sprintf(buf + strlen(buf), "%-11s", complete_cmd_info[i].command);
      if (!(no % 7))
	strcat(buf, "\r\n");
      no++;
    }
  }

  sprintf(buf + strlen(buf), "\r\nFor a total of %d.\r\n", no);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);
}

ACMD(do_players)
{
  int i, count = 0;
  *buf = 0;

  for (i = 0; i <= top_of_p_table; i++) {
    sprintf(buf, "%s  %-20.20s", buf, (player_table + i)->name);
    count++;
    if (count == 3) {
      count = 0;
      strcat(buf, "\r\n");
    }
  }
  page_string(ch->desc, buf, 1);
}

ACMD(do_index)
{
  int i, row = 0, minlen;
  char buf[MAX_STRING_LENGTH], arg[MAX_STRING_LENGTH];
  if (!ch->desc)
    return;

  one_argument(argument, arg);
  if (!*arg) {
    send_to_char("Index will list all help entries matching the argument supplied.\r\nSyntax: index <letter|phrase>\r\n", ch);
    return;
  }
  minlen = strlen(arg);
  send_to_char("Matching help entries:\r\n", ch);
  for (i = 0; i < top_of_helpt; i++) {
    if (!strn_cmp(arg, help_table[i].keyword, minlen)) {
      row++;
      sprintf(buf + strlen(buf), "|%-23.23s |", help_table[i].keyword);
      if ((row % 3) == 0)
	strcat(buf, "\r\n");
    }
  }
  if (ch->desc)
    page_string(ch->desc, buf, 1);
}

ACMD(do_legend)
{
  int counter, columns = 0;

  send_to_char("\r\n&+B                    -=-=-=-=-= &+YLegend of Greyhawk Adventures&+B =-=-=-=-=-&n\r\n\r\n", ch);
  for (counter = 0; counter < NUM_MAP_SYMBOLS - 1; counter++) {
    sprintf(buf, "    &+c%2d:&n %-20.20s %s%s%s&n", counter,
	    map_info[counter].name, map_info[counter].color,
	    map_info[counter].icon, !(++columns % 3) ? "\r\n" : "");
    send_to_char(buf, ch);
  }
  send_to_char("\r\n\r\nBut if you had our plugin, you would be seeing all of this in SVGA!\r\n", ch);
}

ACMD(do_pshow)
{
  char arg1[MAX_INPUT_LENGTH];
  char arg2[MAX_INPUT_LENGTH];
  char *desc;
  struct char_data *victim;
  struct obj_data *obj;
  int tmp;

  two_arguments(argument, arg1, arg2);

  if (!*arg1) {
    send_to_char("Show what to whom?\r\n", ch);
    return;
  } else if (!*arg2) {
    send_to_char("Who did you want to show that to?\r\n", ch);
    return;
  }
  if (!(victim = get_char_vis(ch, arg2))) {
    send_to_char(NOPERSON, ch);
    return;
  } else if (victim == ch) {
    send_to_char("Ha Ha!  Why don't you just look at it?\r\n", ch);
    return;
  } else if (AFF_FLAGGED(victim, AFF_BLIND)) {
    sprintf(buf, "%s is blind and can see nothing.\r\n", GET_NAME(victim));
    send_to_char(buf, ch);
    return;
  } else if (IS_DARK(victim->in_room) && !CAN_SEE_IN_DARK(victim)) {
    send_to_char("It's too dark!\r\n", ch);
    sprintf(buf, "%s tries to show you something, but it's too dark to see.\r\n", GET_NAME(ch));
    send_to_char(buf, victim);
    return;
  } else if ((obj = get_obj_in_list_vis(ch, arg1, ch->carrying)) ||
	(obj = get_object_in_equip_vis(ch, arg1, ch->equipment, &tmp))) {
    if ((desc = find_exdesc(arg1, obj->ex_description)) != NULL) {
      sprintf(buf, "You show %s to %s.\r\n", obj->short_description, GET_NAME(victim));
      send_to_char(buf, ch);
      sprintf(buf, "%s shows you %s.\r\n", GET_NAME(ch), obj->short_description);
      send_to_char(buf, victim);
      send_to_char(desc, victim);
    } else {
      sprintf(buf, "You show %s to %s.\r\n", obj->short_description, GET_NAME(victim));
      send_to_char(buf, ch);
      sprintf(buf, "%s shows you %s.\r\nYou see nothing special about it.\r\n", GET_NAME(ch),
	      obj->short_description);
      send_to_char(buf, victim);
    }
  } else {
    sprintf(buf, "You dont seem to have %s %s.\r\n", AN(arg1), arg1);
    send_to_char(buf, ch);
  }
}


void ReadMagicBook(struct char_data *ch, struct obj_data *obj)
{
  int j;

  if (invalid_class(ch, obj)) {
    send_to_char("Poof! You're dead! Or whatever should happen here...\r\n", ch);
    return;
  }
  if (IS_OBJ_STAT(obj, ITEM_MAGIC)) {
    for (j = 0; j < MAX_OBJ_AFFECT; j++)
      affect_modify(ch, obj->affected[j].location, obj->affected[j].modifier, 0, 0, 0, 0, 0, 0, 0, 0);
    act("The pages of $p disappear as you read them, but upon finishing, you feel somewhat better informed.", FALSE, ch, obj, 0, TO_CHAR);
    REMOVE_BIT(GET_OBJ_EXTRA(obj), ITEM_MAGIC);
  }
}

ACMD(do_watch)
{
  struct char_data *leader = NULL;

  one_argument(argument, buf);

  if (*buf) {
    if (!(leader = get_char_vis(ch, buf)) ||
	IS_AFFECTED(ch, AFF_BLIND) ||
	!victWithinRangeofChar(ch, leader, 9) ||
	!WithinAngle(ch, NULL, leader, NULL, 95, 95)) {
      send_to_char(NOPERSON, ch);
      return;
    }
  } else {
    // tell them who they are watching, if anyone.
    if (!ch->watching)
      send_to_char("You aren't watching anyone.\r\n", ch);
    else
      act("You are watching $N.", FALSE, ch, 0, ch->watching->vict,
	  TO_CHAR);
    return;
  }

  if (ch->watching && (ch->watching->vict == leader)) {
    act("You are already watching $N.", FALSE, ch, 0, ch->watching->vict,
	TO_CHAR);
    return;
  }
  if (leader == ch) {
    if (!ch->watching) {
      send_to_char("You aren't watching anyone.\r\n", ch);
      return;
    }
//       stop_watcher(ch);
  } else {
    if (ch->watching)
      stop_watcher(ch);
    add_watcher(ch, leader);
  }
}
