


/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/


#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"
#include "house.h"
#include "events.h"
#include "skills.h"
#include "dg_scripts.h"

/* extern variables */
extern struct index_data *obj_index;
extern struct str_app_type str_app[];
extern struct room_data *world;
extern struct descriptor_data *descriptor_list;
extern struct room_data *world;
extern struct dex_skill_type dex_app_skill[];
extern struct spell_info_type spell_info[];
extern struct index_data *mob_index;
extern char *class_abbrevs[];
extern char *dirs[];
extern char *dirs_look[];
extern char *distances_look[];

/* extern procedures */
SPECIAL(shop_keeper);
extern char *coin_stringv(int amount);
extern void gain_exp(struct char_data *ch, int gain);

EVENTFUNC(repair_event);

struct repair_event_obj {
  struct char_data *ch;
  struct obj_data *obj;
  char *arg;
};

ACMD(do_repair)
{
  struct obj_data *obj;
  struct repair_event_obj *re;
  int skill;
  char name[MAX_INPUT_LENGTH];

  one_argument(argument, name);

  if (!*name) {
    send_to_char("Repair what?\r\n", ch);
    return;
  }
  if (GET_ACTION(ch)) {
    send_to_char("You're too busy to repair that.\r\n", ch);
    return;
  }
  obj = get_obj_in_list_vis(ch, name, ch->carrying);
  if (!obj) {
    send_to_char("You arent holding that item.\r\n", ch);
    return;
  }
  skill = (GET_OBJ_TYPE(obj) == ITEM_WEAPON) ? SKILL_WEAPONSMITHING :
      (GET_OBJ_TYPE(obj) == ITEM_ARMOR) ? SKILL_ARMORER : 0;
  if (!skill || (GET_SKILL(ch, skill) == 0)) {
    send_to_char("You dont know how to repair that.\r\n", ch);
    return;
  }
  CREATE(re, struct repair_event_obj, 1);

  re->obj = obj;
  re->ch = ch;
  re->arg = str_dup(name);

  GET_ACTION(ch) = event_create(repair_event, re, PASSES_PER_SEC * SECS_PER_ROUND);

  send_to_char("You begin repairing it.\r\n", ch);
}

EVENTFUNC(repair_event)
{
  struct char_data *ch;
  struct obj_data *obj, *temp;
  struct repair_event_obj *re = (struct repair_event_obj *) event_obj;
  int dmg = 0, skill, vnum;
  int DamageItem(struct char_data *ch, struct obj_data *o, int num);
  char *arg;

  ch = re->ch;
  obj = re->obj;
  arg = re->arg;

  if (!GET_ACTION(ch))
    return 0;

  /* Make sure character is still holding the same object */
  for (temp = get_obj_in_list_vis(ch, arg, ch->carrying);
       temp;) {
    if (temp == obj)
      break;
  }
  if (!temp) {
    act("You stop repairing your $o.", TRUE, ch, obj, NULL, TO_CHAR);
    GET_ACTION(ch) = NULL;
    return 0;
  }
  dmg = MAX(0, GET_OBJ_MAX_COND(obj) - GET_OBJ_CONDITION(obj));
  if (dmg == 0) {
    send_to_char("That doesn't need repairing.\r\n", ch);
    GET_ACTION(ch) = NULL;
    return 0;
  }
  /*skill check */
  skill = (GET_OBJ_TYPE(obj) == ITEM_WEAPON) ? SKILL_WEAPONSMITHING :
      SKILL_ARMORER;
  if (GET_SKILL(ch, skill) == 0) {
    send_to_char("You dont know how to repair that.\r\n", ch);
    GET_ACTION(ch) = NULL;
    return 0;
  }
  vnum = (skill == SKILL_WEAPONSMITHING) ? 1421 : 1420;

  temp = GET_EQ(ch, WEAR_HOLD);

  if (!temp || (GET_OBJ_VNUM(temp) != vnum))
    temp = GET_EQ(ch, WEAR_HOLD2);

  if (!temp || (GET_OBJ_VNUM(temp) != vnum)) {
    act("You are not holding the proper item to repair $o.",
	TRUE, ch, obj, NULL, TO_CHAR);
    GET_ACTION(ch) = NULL;
    return 0;
  }
  if (dice(3, 6) > (GET_INT(ch) - 2 + GET_SKILL(ch, skill))) {
    act("Ooops. You made a mistake and damaged your $o.", TRUE,
	ch, obj, NULL, TO_CHAR);
    DamageItem(ch, obj, 100);
    GET_ACTION(ch) = NULL;
    return 0;
  }
  dmg = MIN(dice(1, 4), dmg);

  GET_OBJ_CONDITION(obj) += dmg;

  if (GET_OBJ_CONDITION(obj) == GET_OBJ_MAX_COND(obj)) {
    send_to_char("You have repaired this as much as you can.\r\n", ch);
    GET_ACTION(ch) = NULL;
    return 0;
  } else {
    act("You continue to repair your $o.", TRUE, ch, obj, NULL, TO_CHAR);
    return PASSES_PER_SEC * SECS_PER_ROUND;
  }
}
