/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

/* handling the affected-structures */
void affect_total(struct char_data *ch);
void room_affect_modify(int room, long bitv, bool add);
void obj_affect_modify(struct obj_data *obj, byte loc, sbyte mod, long bitv,
                   long bitv2, long bitv3, long bitv4, long prot,
		   long dete, long cont, bool add); 
void affect_modify(struct char_data *ch, byte loc, sbyte mod, long bitv,
		   long bitv2, long bitv3, long bitv4, long prot, 
		   long dete, long cont, bool add);
void affect_to_char(struct char_data *ch, struct affected_type *af);
void affect_to_room(int room, struct room_affected_type *af);
void affect_to_obj(struct obj_data *obj, struct affected_type *af);
void affect_remove(struct char_data *ch, struct affected_type *af);
void room_affect_remove(int room, struct room_affected_type *af);
void obj_affect_remove(struct obj_data *obj, struct affected_type *af);
void affect_from_char(struct char_data *ch, int type);
bool affected_by_spell(struct char_data *ch, int type);
void affect_join(struct char_data *ch, struct affected_type *af,
		 bool add_dur, bool avg_dur, bool add_mod, bool avg_mod);


/* utility */
char *money_desc(int amount, int type, int king);
struct obj_data *create_money(int amount, int type, int king);
int isname(char *str, char *namelist);
char *fname(char *namelist);
int get_number(char **name);


/* ******** objects *********** */

void obj_to_char(struct obj_data *object, struct char_data *ch);
void obj_from_char(struct obj_data *object);

void equip_char(struct char_data *ch, struct obj_data *obj, int pos);
struct obj_data *unequip_char(struct char_data *ch, int pos);

struct obj_data *get_obj_in_list(char *name, struct obj_data *list);
struct obj_data *get_obj_in_list_num(int num, struct obj_data *list);
struct obj_data *get_obj(char *name);
struct obj_data *get_obj_num(obj_rnum nr);

void obj_to_room(struct obj_data *object, room_rnum room);
void put_obj_to_room(struct obj_data *object, room_rnum room, sh_int x_cord, sh_int y_cord, sh_int z_cord);
void obj_from_room(struct obj_data *object);
void obj_to_obj(struct obj_data *obj, struct obj_data *obj_to);
void obj_from_obj(struct obj_data *obj);
void object_list_new_owner(struct obj_data *list, struct char_data *ch);

void extract_obj(struct obj_data *obj);

/* ******* characters ********* */

struct char_data *get_char_room(char *name, room_rnum room);
struct char_data *get_char_num(mob_rnum nr);
struct char_data *get_char(char *name);

void char_from_room(struct char_data *ch);
void char_to_room(struct char_data *ch, room_rnum room, sh_int from_dir);
void put_char_to_room(struct char_data *ch, room_rnum room, sh_int from_dir, sh_int x_cord, sh_int y_cord, sh_int z_cord);
void extract_char(struct char_data *ch);

/* find if character can see */
struct char_data *get_char_room_vis(struct char_data *ch, char *name);
struct char_data *get_char_room_cord(struct char_data *ch, char *name);
struct char_data *get_player_vis(struct char_data *ch, char *name, int inroom);
struct char_data *get_char_vis(struct char_data *ch, char *name);
struct obj_data *get_obj_in_list_vis(struct char_data *ch, char *name,
				     struct obj_data *list);
struct obj_data *get_obj_in_list_cord(struct char_data *ch, char *name,
				     struct obj_data *list);
struct obj_data *get_obj_vis(struct char_data *ch, char *name);
struct obj_data *get_object_in_equip_vis(struct char_data *ch,
			char *arg, struct obj_data *equipment[], int *j);
struct obj_data *get_held_object_in_equip_vis(struct char_data *ch,
                        char *arg, struct obj_data *equipment[], int *j);


/* find all dots */

int find_all_dots(char *arg);

#define FIND_INDIV	0
#define FIND_ALL	1
#define FIND_ALLDOT	2


/* Generic Find */

int generic_find(char *arg, int bitvector, struct char_data *ch,
		 struct char_data **tar_ch, struct obj_data **tar_obj);

#define FIND_CHAR_ROOM     BIT_1
#define FIND_CHAR_WORLD    BIT_2
#define FIND_OBJ_INV       BIT_3
#define FIND_OBJ_ROOM      BIT_4
#define FIND_OBJ_WORLD     BIT_5
#define FIND_OBJ_EQUIP     BIT_6 


/* prototypes from crash save system */

int Crash_get_filename(char *orig_name, char *filename);
int Crash_delete_file(char *name);
int Crash_delete_crashfile(struct char_data *ch);
int Crash_clean_file(char *name);
void Crash_listrent(struct char_data *ch, char *name);
int Crash_load(struct char_data *ch);
void Crash_crashsave(struct char_data *ch);
void Crash_idlesave(struct char_data *ch);
void Crash_save_all(void);

/* prototypes from fight.c */
void set_fighting(struct char_data *ch, struct char_data *victim);
void stop_fighting(struct char_data *ch);
void stop_follower(struct char_data *ch);
void hit(struct char_data *ch, struct char_data *victim, int type);
void forget(struct char_data *ch, struct char_data *victim);
void remember(struct char_data *ch, struct char_data *victim);
void damage(struct char_data *ch, struct char_data *victim, int dam, int attacktype, int which, int location);
int skill_message(int dam, struct char_data *ch, struct char_data *vict,
		  int attacktype);
void do_knockBack(struct char_data *ch, struct char_data *vict, int dam);
char can_block(struct char_data *ch, struct char_data *vict);
char should_block(struct char_data *ch, int location, int dam);
char successful_block(struct char_data *ch, int location, int mod);
char successful_parry(struct char_data *ch, int mod, struct obj_data *o);
char can_parry(struct char_data *ch, struct char_data *vict);
char should_parry(struct char_data *ch, int location, int dam);
char penetration_number(struct obj_data *shield);
char get_shield_damage_reduction(struct obj_data *shield);
char stopped_by_passive_defense(struct char_data *ch, struct char_data *vict);
char get_damage_reduction(struct char_data *ch, struct char_data *vict);
char makes_dodge(struct char_data *ch);
void damage_to_object(struct obj_data *obj, int dam);
int modify_by_attack(struct char_data *ch, struct obj_data *obj);
int thaco_to_skill(struct char_data *ch);
char get_encumberance(struct char_data *ch);
void critical_miss(struct char_data *ch, int w_type);
int critical_hit(struct char_data *ch, struct char_data *vict, 
				 int damage);
void cripple(struct char_data *ch, int location, int duration);
int has_location(struct char_data *ch, int location);


/* prototypes from regen.c */
int alter_hit(struct char_data *ch, int amount, int location, char above_max);
void alter_mana(struct char_data *ch, int amount);
void alter_move(struct char_data *ch, int amount);
void check_regen_rates(struct char_data *ch);
