/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define	m  (unsigned long)2147483647
#define	q  (unsigned long)127773

#define	a (unsigned int)16807
#define	r (unsigned int)2836

/*
   ** F(z)      = (az)%m
   **   = az-m(az/m)
   **
   ** F(z)  = G(z)+mT(z)
   ** G(z)  = a(z%q)- r(z/q)
   ** T(z)  = (z/q) - (az/m)
   **
   ** F(z)  = a(z%q)- rz/q+ m((z/q) - a(z/m))
   **    = a(z%q)- rz/q+ m(z/q) - az
 */

static unsigned long seed;

void circle_srandom(unsigned long initial_seed)
{
  seed = initial_seed;
}


unsigned long circle_random(void)
{
  register int lo, hi, test;

  hi = seed / q;
  lo = seed % q;

  test = a * lo - r * hi;

  if (test > 0)
    seed = test;
  else
    seed = test + m;

  return seed;
}
