/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define DEFAULT_STAFF_LVL	12
#define DEFAULT_WAND_LVL	12

/* use these values in place of skill levels for spells */
#define MEMINFO_CANTLEARN	0	/* wrong class, or failed learn roll */
#define MEMINFO_UNKNOWN		10	/* default for proper class       */
#define MEMINFO_KNOWN		20	/* learned before, maybe in book */
#define MEMINFO_SCRIBING	30	/* currently scribing this one    */
#define MEMINFO_MEMMING		40	/* currently memorizing this one */
#define MEMINFO_READY		50	/* in mem, ready to cast  */

#define SBOOK_MODE_AT_HAND   1
#define SBOOK_MODE_IN_INV    2
#define SBOOK_MODE_NO_SCROLL 4
#define SBOOK_MODE_NO_BOOK   8

#define SINFO spell_info[spellnum]

#define CAST_UNDEFINED	-1
#define CAST_SPELL	0
#define CAST_POTION	1
#define CAST_WAND	2
#define CAST_STAFF	3
#define CAST_SCROLL	4

#define MAG_DAMAGE	(1 << 0)
#define MAG_AFFECTS	(1 << 1)
#define MAG_UNAFFECTS	(1 << 2)
#define MAG_POINTS	(1 << 3)
#define MAG_ALTER_OBJS	(1 << 4)
#define MAG_GROUPS	(1 << 5)
#define MAG_MASSES	(1 << 6)
#define MAG_AREAS	(1 << 7)
#define MAG_SUMMONS	(1 << 8)
#define MAG_CREATIONS	(1 << 9)
#define MAG_MANUAL	(1 << 10)


#define TYPE_UNDEFINED               -1
#define SPELL_RESERVED_DBC            0		/* SKILL NUMBER ZERO -- RESERVED */

/* PLAYER SPELLS -- Numbered from 1 to MAX_SPELLS */

#define SPELL_BLESS 			1
#define SPELL_COMMAND			2
#define SPELL_CREATE_WATER		3
#define SPELL_CURE_LIGHT		4
#define SPELL_CAUSE_LIGHT		5
#define SPELL_DETECT_EVIL		6
#define SPELL_DETECT_GOOD		7
#define SPELL_DETECT_MAGIC		8
#define SPELL_LIGHT			9
#define SPELL_DARKNESS			10
#define SPELL_PROT_FROM_EVIL		11
#define SPELL_PROT_FROM_GOOD		12
#define SPELL_PURIFY_FOOD_WATER		13
#define SPELL_CONTAM_FOOD_WATER		14
#define SPELL_REMOVE_FEAR		15
#define SPELL_FEAR			16
#define SPELL_RESIST_COLD		17
#define SPELL_SANCTUARY			18
#define SPELL_AUGURY			19
#define SPELL_CHANT			20
#define SPELL_DETECT_CHARM		21
#define SPELL_COMBINE			22
#define SPELL_FIND_TRAPS		23
#define SPELL_HOLD_PERSON		24
#define SPELL_KNOW_ALIGN		25
#define SPELL_RESIST_FIRE		26
#define SPELL_SILENCE_15		27
#define SPELL_SLOW_POISON		28
#define SPELL_SNAKE_CHARM		29
#define SPELL_SPEAK_ANIMALS		30
#define SPELL_SPIRIT_HAMMER		31
#define SPELL_ANIMATE_DEAD		32
#define SPELL_CONTINUAL_LIGHT		33
#define SPELL_CONTINUAL_DARKNESS	34
#define SPELL_CREATE_FOOD		35
#define SPELL_DETECT_POISON             36
#define SPELL_CURE_BLINDNESS		37
#define SPELL_CAUSE_BLINDNESS		38
#define SPELL_CURE_DISEASE		39
#define SPELL_CAUSE_DISEASE		40
#define SPELL_DISPEL_MAGIC		41
#define SPELL_FEIGN_DEATH		42
#define SPELL_GLYPH_WARDING		43
#define SPELL_LOCATE_OBJECT		44
#define SPELL_OBSCURE_OBJECT		45
#define SPELL_PRAYER			46
#define SPELL_REMOVE_CURSE		47
#define SPELL_CURSE			48
#define SPELL_SPEAK_WITH_DEAD		49
#define SPELL_CURE_SERIOUS		50
#define SPELL_CAUSE_SERIOUS		51
#define SPELL_DETECT_LIE		52
#define SPELL_UNDET_LIE			53
#define SPELL_DIVINATION		54
#define SPELL_ENDURE_COLD		55
#define SPELL_LOWER_WATER		56
#define SPELL_RAISE_WATER		57
#define SPELL_NEUT_POISON		58
#define SPELL_POISON			59
#define SPELL_PROT_EVIL_10		60
#define SPELL_PROT_GOOD_10		61
#define SPELL_SPEAK_PLANTS		62
#define SPELL_STICKS_SNAKES		63
#define SPELL_SNAKES_STICKS		64
#define SPELL_TONGUES			65
#define SPELL_REV_TONGUES		66
#define SPELL_ATONEMENT			67
#define SPELL_COMMUNE			68
#define SPELL_CURE_CRITIC		69
#define SPELL_CAUSE_CRITIC		70
#define SPELL_DISPEL_EVIL		71
#define SPELL_DISPEL_GOOD		72
#define SPELL_FLAME_STRIKE		73
#define SPELL_INSECT_PLAGUE		74
#define SPELL_PLANE_SHIFT		75
#define SPELL_QUEST			76
#define SPELL_RAISE_DEAD		77
#define SPELL_SLAY_LIVING		78
#define SPELL_TRUE_SEEING		79
#define SPELL_FALSE_SEEING		80
#define SPELL_AERIAL_SERVANT		81
#define SPELL_ANIMATE_OBJECT		82
#define SPELL_BLADE_BARRIER		83
#define SPELL_CONJURE_ANIMALS		84
#define SPELL_FIND_PATH			85
#define SPELL_LOSE_PATH			86
#define SPELL_HEAL			87
#define SPELL_HARM			88
#define SPELL_PART_WATER		89
#define SPELL_SPEAK_MONSTERS		90
#define SPELL_STONE_TELL		91
#define SPELL_WORD_RECALL		92
#define SPELL_ASTRAL_SPELL		93
#define SPELL_CONTROL_WEATHER		94
#define SPELL_EARTHQUAKE		95
#define SPELL_HOLYWORD			96
#define SPELL_UNHOLYWORD		97
#define SPELL_REGENERATE		98
#define SPELL_WITHER			99
#define SPELL_RESTORATION		100
#define SPELL_ENERGY_DRAIN		101
#define SPELL_RESURECTION		102
#define SPELL_DESTRUCTION		103
#define SPELL_SYMBOL			104
#define SPELL_WIND_WALK			105
#define SPELL_ANIMAL_FRIENDSHIP		106
#define SPELL_ENDURE_HEAT               107
#define SPELL_DETECT_SNARES		108
#define SPELL_ENTANGLE			109
#define SPELL_FAERIE_FIRE		110
#define SPELL_INVIS_ANIMALS		111
#define SPELL_LOCATE_ANIMAL		112
#define SPELL_PASS_WITHOUT_TRACE	113
#define SPELL_INVIS_UNDEAD		114
#define SPELL_MAGICAL_STONE		115
#define SPELL_AID			116
#define SPELL_SHILLELAGH		117
#define SPELL_DUST_DEVIL                118
#define SPELL_BARKSKIN			119
#define SPELL_CHARM_MAMMAL		120
#define SPELL_FIRE_TRAP			121
#define SPELL_HEAT_METAL		122
#define SPELL_CHILL_METAL		123
#define SPELL_LOCATE_PLANTS		124
#define SPELL_OBSCUREMENT		125
#define SPELL_PRODUCE_FLAME		126
#define SPELL_TRIP			127
#define SPELL_WARP_WOOD			128
#define SPELL_CALL_LIGHTNING		129
#define SPELL_HOLD_ANIMAL		130
#define SPELL_PLANT_GROWTH		131
#define SPELL_PROT_FIRE			132
#define SPELL_PYROTECHNICS		133
#define SPELL_SNARE			134
#define SPELL_STONE_SHAPE		135
#define SPELL_SUMMON_INSECTS		136
#define SPELL_TREE			137
#define SPELL_WATER_BREATHING		138
#define SPELL_AIR_BREATHING		139
#define SPELL_ANIMAL_SUMM1		140
#define SPELL_CALL_WOOD_BEINGS		141
#define SPELL_CONT_TEMP_10		142
#define SPELL_HALLUC_FOREST		143
#define SPELL_HOLD_PLANT		144
#define SPELL_PLANT_DOOR		145
#define SPELL_PROD_FIRE			146
#define SPELL_QUENCH_FIRE		147
#define SPELL_PROT_LIGHTNING		148
#define SPELL_REPEL_INSECTS		149
#define SPELL_ANIMAL_GROWTH		150
#define SPELL_REDUCE_ANIMAL		151
#define SPELL_ANIM_SUMM2		152
#define SPELL_ANTI_PLANT_SHELL		153
#define SPELL_COMMUNE_NATURE		154
#define SPELL_CONTROL_WINDS		155
#define SPELL_ENTHRALL			156
#define SPELL_PASS_PLANT		157
#define SPELL_ROCK_MUD			158
#define SPELL_MUD_ROCK			159
#define SPELL_WALL_FIRE			160
#define SPELL_ANIM_SUMM3		161
#define SPELL_ANTI_ANIM_SHELL		162
#define SPELL_CONJ_FIRE_ELEMENTAL	163
#define SPELL_DISMISS_FIRE_ELEMENTAL	164
#define SPELL_FLAME_BLADE		165
#define SPELL_FIRE_SEEDS		166
#define SPELL_TRANS_VIA_PLANTS		167
#define SPELL_TURN_WOOD			168
#define SPELL_WALL_THORNS		169
#define SPELL_WEATHER_SUMMONING		170
#define SPELL_ANIMATE_ROCK		171
#define SPELL_CHARIOT_SUSTARRE		172
#define SPELL_CONFUSION			173
#define SPELL_CONJ_EARTH_ELEMENTAL	174
#define SPELL_DISMISS_EARTH_ELEMENTAL	175
#define SPELL_GOODBERRY			176
#define SPELL_CREEPING_DOOM		177
#define SPELL_BADBERRY			178
#define SPELL_FIRE_STORM		179
#define SPELL_FIRE_QUENCH		180
#define SPELL_REINCARNATE		181
#define SPELL_TRANS_METAL_WOOD		182
#define SPELL_MESSENGER			183
#define SPELL_WITHDRAW			184
#define SPELL_WYVERN_WATCH		185
#define SPELL_FLAME_WALK		186
#define SPELL_MAGICAL_VESTMENT		187
#define SPELL_MELD_INTO_STONE		188
#define SPELL_NEG_PLANE_PROT		189
#define SPELL_REMOVE_PARA		190
#define SPELL_SPIKE_GROWTH		191
#define SPELL_STARSHINE			192
#define SPELL_WATER_WALK		193
#define SPELL_ABJURE			194
#define SPELL_CLOAK_BRAVERY		195
#define SPELL_FREE_ACTION		196
#define SPELL_GIANT_INSECT		197
#define SPELL_SMALL_INSECT		198
#define SPELL_IMBUE_SPELL_ABILITY	199
#define SPELL_REFLECTING_POOL		200
#define SPELL_SPELL_IMMUNITY		201
#define SPELL_AIR_WALK			202
#define SPELL_MAGIC_FONT		203
#define SPELL_MOONBEAM			204
#define SPELL_RAINBOW			205
#define SPELL_SPIKE_STONES		206
#define SPELL_FORBIDDANCE		207
#define SPELL_HEROS_FEAST		208
#define SPELL_LIVEOAK			209
#define SPELL_WATER_TO_DUST		210
#define SPELL_DUST_TO_WATER		211
#define SPELL_CHANGESTAFF		212
#define SPELL_EXACTION			213
#define SPELL_GATE			214
#define SPELL_SUNRAY			215
#define SPELL_SUCCOR			216
#define SPELL_WOOD_TO_METAL		217
#define SPELL_AFFECT_NORMAL_FIRES	218
#define SPELL_ALARM			219
#define SPELL_ARMOR			220
#define SPELL_AUDIBLE_GLAMER		221
#define SPELL_BURNING_HANDS		222
#define SPELL_CANTRIP			223
#define SPELL_CHANGE_SELF		224
#define SPELL_CHILL_TOUCH		225
#define SPELL_COLOR_SPRAY		226
#define SPELL_COMPREHEND_LANGUAGES	227
#define SPELL_OBSCURE_LANGUAGES		228
#define SPELL_DANCING_LIGHTS		229
#define SPELL_DETECT_UNDEAD		230
#define SPELL_ENLARGE			231
#define SPELL_REDUCE			232
#define SPELL_ERASE			233
#define SPELL_FEATHER_FALL		234
#define SPELL_FIND_FAMILIAR		235
#define SPELL_FRIENDS			236
#define SPELL_GAZE_REFLECTION		237
#define SPELL_GREASE			238
#define SPELL_HOLD_PORTAL		239
#define SPELL_HYPNOTISM			240
#define SPELL_IDENTIFY			241
#define SPELL_JUMP			242
#define SPELL_CRYSTALBRITTLE		243
#define SPELL_MAGIC_MISSILE		244
#define SPELL_MENDING			245
#define SPELL_MESSAGE			246
#define SPELL_MOUNT			247
#define SPELL_NYSTUL_MAGICAL_AURA	248
#define SPELL_PHANTASMAL_FORCE		249
#define SPELL_READ_MAGIC		250
#define SPELL_SHIELD			251
#define SPELL_SHOCKING_GRASP		252
#define SPELL_SLEEP			253
#define SPELL_SPIDER_CLIMB		254
#define SPELL_SPOOK			255
#define SPELL_TAUNT			256
#define SPELL_TENSER_FLOATING_DISC	257
#define SPELL_UNSEEN_SERVANT		258
#define SPELL_VENTRILOQUISM		259
#define SPELL_WALL_OF_FOG		260
#define SPELL_WIZARD_MARK		261
#define SPELL_ALTER_SELF		262
#define SPELL_BIND			263
#define SPELL_BLUR			264
#define SPELL_DEAFNESS			265
#define SPELL_DEEPPOCKETS		266
#define SPELL_DETECT_INVISIBILITY	267
#define SPELL_ESP			268
#define SPELL_FLAMING_SPHERE		269
#define SPELL_FOG_CLOUD			270
#define SPELL_FOOLS_GOLD		271
#define SPELL_FORGET			272
#define SPELL_GLITTERDUST		273
#define SPELL_HYPNOTIC_PATTERN		274
#define SPELL_IMPROVED_PHANTASMAL_FORCE	275
#define SPELL_INVISIBILITY		276
#define SPELL_IRRITATION		277
#define SPELL_KNOCK			278
#define SPELL_LEOMUND_TRAP		279
#define SPELL_LEVITATE			280
#define SPELL_MAGIC_MOUTH		281
#define SPELL_MELF_ACID_ARROW		282
#define SPELL_MIRROR_IMAGE		283
#define SPELL_MISDIRECTION		284
#define SPELL_PROTECTION_FROM_CANTRIPS	285
#define SPELL_WEIRD			286
#define SPELL_RAY_OF_ENFEEBLEMENT	287
#define SPELL_ROPE_TRICK		288
#define SPELL_SCARE			289
#define SPELL_SHATTER			290
#define SPELL_SPECTRAL_HAND		291
#define SPELL_STINKING_CLOUD		292
#define SPELL_STRENGTH			293
#define SPELL_SUMMON_SWARM		294
#define SPELL_TASHA_UNCONTROLLABLE_HIDEOUS_LAUGHTER	295
#define SPELL_WEB			296
#define SPELL_WHISPERING_WIND		297
#define SPELL_WIZARD_LOCK		298
#define SPELL_BLINK			299
#define SPELL_CLAIRAUDIENCE		300
#define SPELL_CLAIRVOYANCE		301
#define SPELL_DELUDE			302
#define SPELL_EXPLOSIVE_RUNES		303
#define SPELL_FIREBALL			304
#define SPELL_FLAME_ARROW		305
#define SPELL_FLY			306
#define SPELL_GUST_OF_WIND		307
#define SPELL_HASTE			308
#define SPELL_HOLD_UNDEAD		309
#define SPELL_ILLUSIONARY_SCRIPT	310
#define SPELL_INFRAVISION		311
#define SPELL_INVISIBILITY_10		312
#define SPELL_ITEM			313
#define SPELL_LEOMUND_TINY_HUT		314
#define SPELL_LIGHTNING_BOLT		315
#define SPELL_MELF_MINUTE_METEORS	316
#define SPELL_MONSTER_SUMMONING_I	317
#define SPELL_NON_DETECTION		318
#define SPELL_PHANTOM_STEED		319
#define SPELL_PROTECTION_FROM_NORMAL_MISSILES	320
#define SPELL_SECRET_PAGE		321
#define SPELL_SEPIA_SNAKE_SIGIL		322
#define SPELL_SLOW			323
#define SPELL_SPECTRAL_FORCE		324
#define SPELL_SUGGESTION		325
#define SPELL_VAMPIRIC_TOUCH		326
#define SPELL_WIND_WALL			327
#define SPELL_WRAITHFORM		328
#define SPELL_CHARM_MONSTER		329
#define SPELL_FORESIGHT			330
#define SPELL_CONTAGION			331
#define SPELL_DETECT_SCRYING		332
#define SPELL_DIG			333
#define SPELL_DIMENSION_DOOR		334
#define SPELL_EMOTION			335
#define SPELL_ENCHANTED_WEAPON		336
#define SPELL_ENERVATION		337
#define SPELL_EVARD_BLACK_TENTACLES	338
#define SPELL_EXTENSION_I		339
#define SPELL_WISH			340
#define SPELL_FIRE_CHARM		341
#define SPELL_FIRE_SHIELD		342
#define SPELL_IMPRISONMENT		343
#define SPELL_FUMBLE			344
#define SPELL_HALLUCINATORY_TERRAIN	345
#define SPELL_ICE_STORM			346
#define SPELL_ILLUSIONARY_WALL		347
#define SPELL_IMPROVED_INVISIBILITY	348
#define SPELL_LEOMUND_SECURE_SHELTER	349
#define SPELL_MAGIC_MIRROR		350
#define SPELL_MASSMORPH			351
#define SPELL_MINOR_CREATION		352
#define SPELL_MINOR_GLOBE_OF_INVULNERABILITY	353
#define SPELL_MONSTER_SUMMONING_II	354
#define SPELL_OTILUKE_RESILIENT_SPHERE	355
#define SPELL_PHANTASMAL_KILLER		356
#define SPELL_METEOR_SWARM		357
#define SPELL_POLYMORPH_OTHER		358
#define SPELL_POLYMORPH_SELF		359
#define SPELL_RAINBOW_PATTERN		360
#define SPELL_RARY_MNEMONIC_ENHANCER	361
#define SPELL_SHADOW_MONSTERS		362
#define SPELL_SHOUT			363
#define SPELL_SOLID_FOG			364
#define SPELL_STONESKIN			365
#define SPELL_VACANCY			366
#define SPELL_WALL_OF_FIRE		367
#define SPELL_WALL_OF_ICE		368
#define SPELL_WIZARD_EYE		369
#define SPELL_ADVANCED_ILLUSION		370
#define SPELL_AIRY_WATER		371
#define SPELL_MONSTER_SUMMONING_VII	372
#define SPELL_AVOIDANCE			373
#define SPELL_BIGBY_INTERPOSING_HAND	374
#define SPELL_CHAOS			375
#define SPELL_CLOUDKILL			376
#define SPELL_CONE_OF_COLD		377
#define SPELL_CONJURE_ELEMENTAL		378
#define SPELL_CONTACT_OTHER_PLANE	379
#define SPELL_DEMI_SHADOW_MONSTERS	380
#define SPELL_DISMISSAL			381
#define SPELL_DISTANCE_DISTORTION	382
#define SPELL_DOMINATION		383
#define SPELL_DREAM			384
#define SPELL_EXTENSION_II		385
#define SPELL_FABRICATE			386
#define SPELL_FALSE_VISION		387
#define SPELL_FEEBLEMIND		388
#define SPELL_HOLD_MONSTER		389
#define SPELL_LEOMUND_LAMENTABLE_BELABORMENT	390
#define SPELL_LEOMUND_SECRET_CHEST	391
#define SPELL_MAGIC_JAR			392
#define SPELL_MAJOR_CREATION		393
#define SPELL_MONSTER_SUMMONING_III	394
#define SPELL_MORDENKAINEN_FAITHFUL_HOUND	395
#define SPELL_PASSWALL			396
#define SPELL_SEEMING			397
#define SPELL_SENDING			398
#define SPELL_SHADOW_DOOR		399
#define SPELL_SHADOW_MAGIC		400
#define SPELL_MORDENKAINEN_DISJUNCTION	401
#define SPELL_SUMMON_SHADOW		402
#define SPELL_TELEKINESIS		403
#define SPELL_TELEPORT			404
#define SPELL_TRANSMUTE_ROCK_TO_MUD	405
#define SPELL_TRANSMUTE_MUD_TO_ROCK	406
#define SPELL_WALL_OF_FORCE		407
#define SPELL_WALL_OF_IRON		408
#define SPELL_WALL_OF_STONE		409
#define SPELL_ANTI_MAGIC_SHELL		410
#define SPELL_BIGBY_FORCEFUL_HAND	411
#define SPELL_CHAIN_LIGHTNING		412
#define SPELL_POWER_WORD_KILL		413
#define SPELL_CONTINGENCY		414
#define SPELL_DEATH_FOG			416
#define SPELL_DEATH_SPELL		417
#define SPELL_DEMI_SHADOW_MAGIC		418
#define SPELL_DISINTEGRATE		419
#define SPELL_ENCHANT_AN_ITEM		420
#define SPELL_ENSNAREMENT		421
#define SPELL_EXTENSION_III		422
#define SPELL_EYEBITE			423
#define SPELL_GEAS			424
#define SPELL_GLASSEE			425
#define SPELL_GLOBE_OF_INVULNERABILITY	426
#define SPELL_GUARDS_AND_WARDS		427
#define SPELL_INVISIBLE_STALKER		428
#define SPELL_LEGEND_LORE		429
#define SPELL_MASS_SUGGESTION		430
#define SPELL_MIRAGE_ARCANA		431
#define SPELL_MISLEAD			432
#define SPELL_MONSTER_SUMMONING_IV	433
#define SPELL_MORDENKAINEN_LUCUBRATION	434
#define SPELL_MOVE_EARTH		435
#define SPELL_OTILUKE_FREEZING_SPHERE	436
#define SPELL_PRISMATIC_SPHERE		437
#define SPELL_PERMANENT_ILLUSION	437
#define SPELL_PROGRAMMED_ILLUSION	439
#define SPELL_PROJECT_IMAGE		440
#define SPELL_REINCARNATION		441
#define SPELL_REPULSION			442
#define SPELL_SHADES			443
#define SPELL_STONE_TO_FLESH		444
#define SPELL_FLESH_TO_STONE		445
#define SPELL_TENSER_TRANSFORMATION	446
#define SPELL_SHAPE_CHANGE		447
#define SPELL_VEIL			448
#define SPELL_BANISHMENT		449
#define SPELL_BIGBY_GRASPING_HAND	450
#define SPELL_CHARM_PLANTS		451
#define SPELL_CONTROL_UNDEAD		452
#define SPELL_DELAYED_BLAST_FIREBALL	453
#define SPELL_DRAWMIJ_INSTANT_SUMMONS	454
#define SPELL_DUO_DIMENSION		455
#define SPELL_FINGER_OF_DEATH		456
#define SPELL_FORCECAGE			457
#define SPELL_LIMITED_WISH		458
#define SPELL_MASS_INVISIBILITY		459
#define SPELL_MONSTER_SUMMONING_V	460
#define SPELL_MORDENKAINEN_MAGNIFICENT_MANSION	461
#define SPELL_MORDENKAINEN_SWORD	462
#define SPELL_PHASE_DOOR		463
#define SPELL_POWER_WORD_STUN		464
#define SPELL_PRISMATIC_SPRAY		465
#define SPELL_REVERSE_GRAVITY		466
#define SPELL_SEQUESTER			467
#define SPELL_SHADOW_WALK		468
#define SPELL_SIMULACRUM		469
#define SPELL_SPELL_TURNING		470
#define SPELL_STATUE			471
#define SPELL_TELEPORT_WITHOUT_ERROR	472
#define SPELL_VANISH			473
#define SPELL_VISION			474
#define SPELL_ANTIPATHY_SYMPATHY	475
#define SPELL_BIGBY_CLENCHED_FIST	476
#define SPELL_BINDING			477
#define SPELL_CLONE			478
#define SPELL_DEMAND			479
#define SPELL_GLASSTEEL			480
#define SPELL_INCENDIARY_CLOUD		481
#define SPELL_MASS_CHARM		482
#define SPELL_MAZE			483
#define SPELL_MIND_BLANK		484
#define SPELL_MONSTER_SUMMONING_VI	485
#define SPELL_OTILUKE_TELEKINETIC_SPHERE	486
#define SPELL_OTTO_IRRESISTIBLE_DANCE	487
#define SPELL_PERMANENCY		488
#define SPELL_POLYMORPH_ANY_OBJECT	489
#define SPELL_POWER_WORD_BLIND		490
#define SPELL_PRISMATIC_WALL		491
#define SPELL_SCREEN			492
#define SPELL_SERTEN_SPELL_IMMUNITY	493
#define SPELL_SINK			494
#define SPELL_TEMPORAL_STASIS		495
#define SPELL_TRAP_THE_SOUL		496
#define SPELL_TIME_STOP			497
#define SPELL_BIGBY_CRUSHING_HAND	498
#define SPELL_COLD_SHIELD		499
#define SPELL_BLINDNESS			500
#define SPELL_CHARM_PERSON		501
#define SPELL_UNDETECTABLE_CHARM	502
#define SPELL_CAUSE_FEAR		503
#define SPELL_CAUSE_DEAFNESS		504
#define SPELL_CURE_DEAFNESS		505


/* Insert new spells here, up to MAX_SPELLS */
#define MAX_SPELLS		    520
#define LAST_SPELL                  507		/* last number +2 */
#define TOP_SPELL_DEFINE	    505

/*
 *  NON-PLAYER AND OBJECT SPELLS AND SKILLS
 *  The practice levels for the spells and skills below are _not_ recorded
 *  in the playerfile; therefore, the intended use is for spells and skills
 *  associated with objects (such as SPELL_IDENTIFY used with scrolls of
 *  identify) or non-players (such as NPC-only spells).
 */

#define SPELL_FIRE_BREATH            506
#define SPELL_GAS_BREATH             507
#define SPELL_FROST_BREATH           508
#define SPELL_ACID_BREATH            509
#define SPELL_LIGHTNING_BREATH       510

/* ??? Why are these numbered so low? That leaves us with little room
       left for more object spells, of which I foresee numerous ??? */
#define SKILL_PARRY				 511
#define SKILL_PARRY2				 512
#define SKILL_PARRY3				 513
#define SKILL_BLOCK					 514
#define SKILL_FEINT					 515

/* WEAPON ATTACK TYPES */

#define TYPE_HIT                     (MAX_SPELLS+1)
#define TYPE_STING                   (MAX_SPELLS+2)
#define TYPE_WHIP                    (MAX_SPELLS+3)
#define TYPE_SLASH                   (MAX_SPELLS+4)
#define TYPE_BITE                    (MAX_SPELLS+5)
#define TYPE_BLUDGEON                (MAX_SPELLS+6)
#define TYPE_CRUSH                   (MAX_SPELLS+7)
#define TYPE_POUND                   (MAX_SPELLS+8)
#define TYPE_CLAW                    (MAX_SPELLS+9)
#define TYPE_MAUL                    (MAX_SPELLS+10)
#define TYPE_THRASH                  (MAX_SPELLS+11)
#define TYPE_PIERCE                  (MAX_SPELLS+12)
#define TYPE_BLAST		     (MAX_SPELLS+13)
#define TYPE_PUNCH		     (MAX_SPELLS+14)
#define TYPE_STAB		     (MAX_SPELLS+15)
#define TYPE_CHIP		     (MAX_SPELLS+16)

#define TYPE_WEAPON_END		     MAX_SPELLS+30

#define IS_WEAPON(type) (((type) >= TYPE_HIT) && ((type) < TYPE_WEAPON_END))

#define IS_IMPALE(type) (((type) == TYPE_STING) || ((type) == TYPE_SLASH) \
                            || ((type) == TYPE_BITE) || ((type) == TYPE_CLAW) \
                            || ((type) == TYPE_PIERCE) || ((type) == TYPE_STAB))

#define IS_CUT(type) (((type) == TYPE_WHIP) || ((type) == TYPE_SLASH) \
                        || ((type) == TYPE_CLAW) || ((type) == TYPE_PIERCE))

#define IS_CRUSH(type) (((type) == TYPE_BLUDGEON) || ((type) == TYPE_CRUSH) \
                         || ((type) == TYPE_POUND) || ((type) == TYPE_MAUL) \
                         || ((type) == TYPE_THRASH) || ((type) == TYPE_PUNCH) \
                         || ((type) == TYPE_HIT))

#define TYPE_FIRE		     TYPE_WEAPON_END+1
#define TYPE_COLD		     TYPE_WEAPON_END+2
#define TYPE_ELECTRICITY	     TYPE_WEAPON_END+3
#define TYPE_ACID		     TYPE_WEAPON_END+4
#define TYPE_BLOW		     TYPE_WEAPON_END+5
#define TYPE_DESTROY		     TYPE_WEAPON_END+6
#define TYPE_FALLING		     TYPE_WEAPON_END+7
#define TYPE_DROWNING		     TYPE_WEAPON_END+8

#define TYPE_SUFFERING		     MAX_SPELLS+50

#define FORM_NONE	0
#define FORM_DEFAULT	FORM_NONE
#define FORM_THRUST	1
#define FORM_SWING	2
#define FORM_CLUB	3

#define SAVING_PARA   0
#define SAVING_ROD    1
#define SAVING_PETRI  2
#define SAVING_BREATH 3
#define SAVING_SPELL  4

#define SAVE_NONE     0
#define SAVE_HALF     1
#define SAVE_NEG      2
#define SAVE_SPECIAL  3

#define TAR_IGNORE        BIT_1
#define TAR_CHAR_ROOM     BIT_2
#define TAR_CHAR_WORLD    BIT_3
#define TAR_FIGHT_SELF    BIT_4
#define TAR_FIGHT_VICT    BIT_5
#define TAR_SELF_ONLY     BIT_6	/* Only a check, use with i.e. TAR_CHAR_ROOM */
#define TAR_NOT_SELF      BIT_7	/* Only a check, use with i.e. TAR_CHAR_ROOM */
#define TAR_OBJ_INV       BIT_8
#define TAR_OBJ_ROOM      BIT_9
#define TAR_OBJ_WORLD     BIT_10
#define TAR_OBJ_EQUIP     BIT_11
#define TAR_ROOM_RANGE    BIT_12	/*For effects on room blocks */
#define TAR_ROOM_WORLD    BIT_13

#define COM_VERBAL   1
#define COM_SOMATIC  2
#define COM_MATERIAL 4

#define SHAPE_UNDEFINED 0
#define SHAPE_SPHERE	1
#define SHAPE_CONE	2
#define SHAPE_CLOUD	3
#define SHAPE_LINE	4
#define SHAPE_SQUARE    5

#define SPHERE_ALL		BIT_1
#define SPHERE_ANIMAL		BIT_2
#define SPHERE_ASTRAL		BIT_3
#define SPHERE_CHARM		BIT_4
#define SPHERE_COMBAT		BIT_5
#define SPHERE_CREATION		BIT_6
#define SPHERE_DIVINATION	BIT_7
#define SPHERE_ELEMENTAL	BIT_8
#define SPHERE_GUARDIAN		BIT_9
#define SPHERE_HEALING		BIT_10
#define SPHERE_NECROMANTIC	BIT_11
#define SPHERE_PLANT		BIT_12
#define SPHERE_PROTECTION	BIT_13
#define SPHERE_SUMMONING	BIT_14
#define SPHERE_SUN		BIT_15
#define SPHERE_WEATHER		BIT_16
#define MAX_SPHERE		16

#define SCHOOL_ABJURATION	BIT_1
#define SCHOOL_ALTERATION	BIT_2
#define SCHOOL_CONJURATION	BIT_3
#define SCHOOL_SUMMONING	BIT_4
#define SCHOOL_ENCHANTMENT	BIT_5
#define SCHOOL_CHARM		BIT_6
#define SCHOOL_ILLUSION		BIT_7
#define SCHOOL_PHANTASM		BIT_8
#define SCHOOL_INVOCATION	BIT_9
#define SCHOOL_EVOCATION	BIT_10
#define SCHOOL_LESSER_DIVIN	BIT_11
#define SCHOOL_GREATER_DIVIN	BIT_12
#define SCHOOL_NECROMANCY	BIT_13
#define MAX_SCHOOL		13

#define ABJURER		1
#define CONJURER	2
#define DIVINER		3
#define ENCHANTER	4
#define INVOKER		5
#define NECROMANCER	6
#define TRANSMUTER	7
#define NUM_SPECIALIST  7

#define HIT_ALL		0
#define HIT_FRIEND	1
#define HIT_ENEMY	2

struct spell_info_type {
  byte min_position;		/* Position for caster   */
  int spell;			/*Spell type */
  int range;			/*Spell range in map blocks */
  int range_by_level;
  int area_of_affect;		/*radius of affect */
  int area_by_level;
  int duration;			/*duration of spell */
  byte shape;
  byte hits;
  void (*spell_pointer) (int, struct char_data *, int, int,
			 struct char_data *, struct obj_data *,
			 struct location_data * loc);
   byte(*routines) (int, struct char_data *, struct obj_data *, struct char_data *,
                    struct obj_data *, struct location_data *, int);

  int min_level[NUM_CLASSES];
  byte violent;
  byte delay;			/* How long until spell goes off        */
  byte lag;			/* How long you're busy after spell goes off */
  int targets;			/* See below for use with TAR_XXX  */

  byte components;		/* See below for use with COM_XXX */
  int mat_comp[NUM_CLASSES];	/*componets required */
  long school;			/* bit for school */
  long sphere;			/* bit for sphere */
};

/* Possible Targets:

   bit 0 : IGNORE TARGET
   bit 1 : PC/NPC in room
   bit 2 : PC/NPC in world
   bit 3 : Object held
   bit 4 : Object in inventory
   bit 5 : Object in room
   bit 6 : Object in world
   bit 7 : If fighting, and no argument, select tar_char as self
   bit 8 : If fighting, and no argument, select tar_char as victim (fighting)
   bit 9 : If no argument, select self, if argument check that it IS self.

 */

/* possible components

   bit 1: Verbal
   bit 2: Somantic
   bit 3: Material

 */


#define SPELL_TYPE_SPELL   0
#define SPELL_TYPE_POTION  1
#define SPELL_TYPE_WAND    2
#define SPELL_TYPE_STAFF   3
#define SPELL_TYPE_SCROLL  4


/* Attacktypes with grammar */

struct attack_hit_type {
  char *singular;
  char *plural;
  const char *damaged;
};

#define CALL_ROUTINE(spellname,level, vict,obj,loc)\
		(spellname(level, NULL, NULL, vict, obj, loc, 0))

#define AROUTINE(spellname) \
byte spellname(int level, struct char_data *ch, struct obj_data *obj,\
               struct char_data *vict, struct obj_data *t_obj,\
               struct location_data *t_loc, int saved)

#define ASPELL(spellname) \
void	spellname(int level, struct char_data *ch, \
		  struct char_data *victim, struct obj_data *obj,\
                  struct location_data *loc, int savetype,\
                  int casttype)

#define CSPELL(spellname) \
void	spellname(int level, struct char_data *ch, int casttype, \
		  int savetype, struct char_data *victim, struct obj_data *obj,\
                  struct location_data *loc)

#define MANUAL_SPELL(spellname)	spellname(level, caster, cvict, ovict);

/* should be removed */
ASPELL(spell_recall);
ASPELL(spell_summon);
ASPELL(spell_information);
/* end remove */

ASPELL(spell_bless);
ASPELL(spell_command);
ASPELL(spell_create_water);
ASPELL(spell_cure_light);
ASPELL(spell_cause_light);
ASPELL(spell_detect_evil);
ASPELL(spell_detect_good);
ASPELL(spell_detect_magic);
ASPELL(spell_light);
ASPELL(spell_darkness);
ASPELL(spell_prot_from_evil);
ASPELL(spell_prot_from_good);
ASPELL(spell_purify_food_water);
ASPELL(spell_contam_food_water);
ASPELL(spell_remove_fear);
ASPELL(spell_fear);
ASPELL(spell_resist_cold);
ASPELL(spell_sanctuary);
ASPELL(spell_augury);
ASPELL(spell_chant);
ASPELL(spell_detect_charm);
ASPELL(spell_combine);
ASPELL(spell_find_traps);
ASPELL(spell_hold_person);
ASPELL(spell_know_align);
ASPELL(spell_resist_fire);
ASPELL(spell_silence_15);
ASPELL(spell_slow_poison);
ASPELL(spell_snake_charm);
ASPELL(spell_speak_animals);
ASPELL(spell_spirit_hammer);
ASPELL(spell_animate_dead);
ASPELL(spell_continual_light);
ASPELL(spell_continual_darkness);
ASPELL(spell_create_food);
ASPELL(spell_detect_poison);
ASPELL(spell_cure_blindness);
ASPELL(spell_cure_deafness);
ASPELL(spell_cause_blindness);
ASPELL(spell_cause_deafness);
ASPELL(spell_cure_disease);
ASPELL(spell_cause_disease);
ASPELL(spell_dispel_magic);
ASPELL(spell_feign_death);
ASPELL(spell_glyph_warding);
ASPELL(spell_locate_object);
ASPELL(spell_obscure_object);
ASPELL(spell_prayer);
ASPELL(spell_remove_curse);
ASPELL(spell_curse);
ASPELL(spell_speak_with_dead);
ASPELL(spell_cure_serious);
ASPELL(spell_cause_serious);
ASPELL(spell_detect_lie);
ASPELL(spell_undet_lie);
ASPELL(spell_divination);
ASPELL(spell_endure_cold);
ASPELL(spell_lower_water);
ASPELL(spell_raise_water);
ASPELL(spell_neut_poison);
ASPELL(spell_poison);
ASPELL(spell_prot_evil_10);
ASPELL(spell_prot_good_10);
ASPELL(spell_speak_plants);
ASPELL(spell_sticks_snakes);
ASPELL(spell_snakes_sticks);
ASPELL(spell_tongues);
ASPELL(spell_rev_tongues);
ASPELL(spell_atonement);
ASPELL(spell_commune);
ASPELL(spell_cure_critic);
ASPELL(spell_cause_critic);
ASPELL(spell_dispel_evil);
ASPELL(spell_dispel_good);
ASPELL(spell_flame_strike);
ASPELL(spell_insect_plague);
ASPELL(spell_plane_shift);
ASPELL(spell_quest);
ASPELL(spell_raise_dead);
ASPELL(spell_slay_living);
ASPELL(spell_true_seeing);
ASPELL(spell_false_seeing);
ASPELL(spell_aerial_servant);
ASPELL(spell_animate_object);
ASPELL(spell_blade_barrier);
ASPELL(spell_conjure_animals);
ASPELL(spell_find_path);
ASPELL(spell_lose_path);
ASPELL(spell_heal);
ASPELL(spell_harm);
ASPELL(spell_part_water);
ASPELL(spell_speak_monsters);
ASPELL(spell_stone_tell);
ASPELL(spell_word_recall);
ASPELL(spell_astral_spell);
ASPELL(spell_control_weather);
ASPELL(spell_earthquake);
ASPELL(spell_holyword);
ASPELL(spell_unholyword);
ASPELL(spell_regenerate);
ASPELL(spell_wither);
ASPELL(spell_restoration);
ASPELL(spell_energy_drain);
ASPELL(spell_resurection);
ASPELL(spell_destruction);
ASPELL(spell_symbol);
ASPELL(spell_wind_walk);
ASPELL(spell_animal_friendship);
ASPELL(spell_endure_heat);
ASPELL(spell_detect_snares);
ASPELL(spell_entangle);
ASPELL(spell_faerie_fire);
ASPELL(spell_invis_animals);
ASPELL(spell_locate_animal);
ASPELL(spell_pass_without_trace);
ASPELL(spell_invis_undead);
ASPELL(spell_magical_stone);
ASPELL(spell_aid);
ASPELL(spell_shillelagh);
ASPELL(spell_dust_devil);
ASPELL(spell_barkskin);
ASPELL(spell_charm_mammal);
ASPELL(spell_fire_trap);
ASPELL(spell_heat_metal);
ASPELL(spell_chill_metal);
ASPELL(spell_locate_plants);
ASPELL(spell_obscurement);
ASPELL(spell_produce_flame);
ASPELL(spell_trip);
ASPELL(spell_warp_wood);
ASPELL(spell_call_lightning);
ASPELL(spell_hold_animal);
ASPELL(spell_plant_growth);
ASPELL(spell_prot_fire);
ASPELL(spell_pyrotechnics);
ASPELL(spell_snare);
ASPELL(spell_stone_shape);
ASPELL(spell_summon_insects);
ASPELL(spell_tree);
ASPELL(spell_water_breathing);
ASPELL(spell_air_breathing);
ASPELL(spell_animal_summ1);
ASPELL(spell_call_wood_beings);
ASPELL(spell_cont_temp_10);
ASPELL(spell_halluc_forest);
ASPELL(spell_hold_plant);
ASPELL(spell_plant_door);
ASPELL(spell_prod_fire);
ASPELL(spell_quench_fire);
ASPELL(spell_prot_lightning);
ASPELL(spell_repel_insects);
ASPELL(spell_animal_growth);
ASPELL(spell_reduce_animal);
ASPELL(spell_anim_summ2);
ASPELL(spell_anti_plant_shell);
ASPELL(spell_commune_nature);
ASPELL(spell_control_winds);
ASPELL(spell_enthrall);
ASPELL(spell_pass_plant);
ASPELL(spell_rock_mud);
ASPELL(spell_mud_rock);
ASPELL(spell_wall_fire);
ASPELL(spell_anim_summ3);
ASPELL(spell_anti_anim_shell);
ASPELL(spell_conj_fire_elemental);
ASPELL(spell_dismiss_fire_elemental);
ASPELL(spell_flame_blade);
ASPELL(spell_fire_seeds);
ASPELL(spell_trans_via_plants);
ASPELL(spell_turn_wood);
ASPELL(spell_wall_thorns);
ASPELL(spell_weather_summoning);
ASPELL(spell_animate_rock);
ASPELL(spell_chariot_sustarre);
ASPELL(spell_confusion);
ASPELL(spell_conj_earth_elemental);
ASPELL(spell_dismiss_earth_elemental);
ASPELL(spell_goodberry);
ASPELL(spell_creeping_doom);
ASPELL(spell_badberry);
ASPELL(spell_fire_storm);
ASPELL(spell_fire_quench);
ASPELL(spell_reincarnate);
ASPELL(spell_trans_metal_wood);
ASPELL(spell_messenger);
ASPELL(spell_withdraw);
ASPELL(spell_wyvern_watch);
ASPELL(spell_flame_walk);
ASPELL(spell_magical_vestment);
ASPELL(spell_meld_into_stone);
ASPELL(spell_neg_plane_prot);
ASPELL(spell_remove_para);
ASPELL(spell_spike_growth);
ASPELL(spell_starshine);
ASPELL(spell_water_walk);
ASPELL(spell_abjure);
ASPELL(spell_cloak_bravery);
ASPELL(spell_free_action);
ASPELL(spell_giant_insect);
ASPELL(spell_small_insect);
ASPELL(spell_imbue_spell_ability);
ASPELL(spell_reflecting_pool);
ASPELL(spell_spell_immunity);
ASPELL(spell_air_walk);
ASPELL(spell_magic_font);
ASPELL(spell_moonbeam);
ASPELL(spell_rainbow);
ASPELL(spell_spike_stones);
ASPELL(spell_forbiddance);
ASPELL(spell_heros_feast);
ASPELL(spell_liveoak);
ASPELL(spell_water_to_dust);
ASPELL(spell_dust_to_water);
ASPELL(spell_changestaff);
ASPELL(spell_exaction);
ASPELL(spell_gate);
ASPELL(spell_sunray);
ASPELL(spell_succor);
ASPELL(spell_wood_to_metal);
ASPELL(spell_affect_normal_fires);
ASPELL(spell_alarm);
ASPELL(spell_armor);
ASPELL(spell_audible_glamer);
ASPELL(spell_burning_hands);
ASPELL(spell_cantrip);
ASPELL(spell_change_self);
ASPELL(spell_chill_touch);
ASPELL(spell_color_spray);
ASPELL(spell_comprehend_languages);
ASPELL(spell_obscure_languages);
ASPELL(spell_dancing_lights);
ASPELL(spell_detect_undead);
ASPELL(spell_enlarge);
ASPELL(spell_reduce);
ASPELL(spell_erase);
ASPELL(spell_feather_fall);
ASPELL(spell_find_familiar);
ASPELL(spell_friends);
ASPELL(spell_gaze_reflection);
ASPELL(spell_grease);
ASPELL(spell_hold_portal);
ASPELL(spell_hypnotism);
ASPELL(spell_identify);
ASPELL(spell_jump);
ASPELL(spell_crystalbrittle);
ASPELL(spell_magic_missile);
ASPELL(spell_mending);
ASPELL(spell_message);
ASPELL(spell_mount);
ASPELL(spell_nystul_magical_aura);
ASPELL(spell_phantasmal_force);
ASPELL(spell_read_magic);
ASPELL(spell_shield);
ASPELL(spell_shocking_grasp);
ASPELL(spell_sleep);
ASPELL(spell_spider_climb);
ASPELL(spell_spook);
ASPELL(spell_taunt);
ASPELL(spell_tenser_floating_disc);
ASPELL(spell_unseen_servant);
ASPELL(spell_ventriloquism);
ASPELL(spell_wall_of_fog);
ASPELL(spell_wizard_mark);
ASPELL(spell_alter_self);
ASPELL(spell_bind);
ASPELL(spell_blur);
ASPELL(spell_deafness);
ASPELL(spell_deeppockets);
ASPELL(spell_detect_invisibility);
ASPELL(spell_esp);
ASPELL(spell_flaming_sphere);
ASPELL(spell_fog_cloud);
ASPELL(spell_fools_gold);
ASPELL(spell_forget);
ASPELL(spell_glitterdust);
ASPELL(spell_hypnotic_pattern);
ASPELL(spell_improved_phantasmal_force);
ASPELL(spell_invisibility);
ASPELL(spell_irritation);
ASPELL(spell_knock);
ASPELL(spell_leomund_trap);
ASPELL(spell_levitate);
ASPELL(spell_magic_mouth);
ASPELL(spell_melf_acid_arrow);
ASPELL(spell_mirror_image);
ASPELL(spell_misdirection);
ASPELL(spell_protection_from_cantrips);
ASPELL(spell_weird);
ASPELL(spell_ray_of_enfeeblement);
ASPELL(spell_rope_trick);
ASPELL(spell_scare);
ASPELL(spell_shatter);
ASPELL(spell_spectral_hand);
ASPELL(spell_stinking_cloud);
ASPELL(spell_strength);
ASPELL(spell_summon_swarm);
ASPELL(spell_tasha_uncontrollable_hideous_laughter);
ASPELL(spell_web);
ASPELL(spell_whispering_wind);
ASPELL(spell_wizard_lock);
ASPELL(spell_blink);
ASPELL(spell_clairaudience);
ASPELL(spell_clairvoyance);
ASPELL(spell_delude);
ASPELL(spell_explosive_runes);
ASPELL(spell_fireball);
ASPELL(spell_flame_arrow);
ASPELL(spell_fly);
ASPELL(spell_gust_of_wind);
ASPELL(spell_haste);
ASPELL(spell_hold_undead);
ASPELL(spell_illusionary_script);
ASPELL(spell_infravision);
ASPELL(spell_invisibility_10);
ASPELL(spell_item);
ASPELL(spell_leomund_tiny_hut);
ASPELL(spell_lightning_bolt);
ASPELL(spell_melf_minute_meteors);
ASPELL(spell_monster_summoning_i);
ASPELL(spell_non_detection);
ASPELL(spell_phantom_steed);
ASPELL(spell_protection_from_normal_missiles);
ASPELL(spell_secret_page);
ASPELL(spell_sepia_snake_sigil);
ASPELL(spell_slow);
ASPELL(spell_spectral_force);
ASPELL(spell_suggestion);
ASPELL(spell_vampiric_touch);
ASPELL(spell_wind_wall);
ASPELL(spell_wraithform);
ASPELL(spell_charm_monster);
ASPELL(spell_foresight);
ASPELL(spell_contagion);
ASPELL(spell_detect_scrying);
ASPELL(spell_dig);
ASPELL(spell_dimension_door);
ASPELL(spell_emotion);
ASPELL(spell_enchanted_weapon);
ASPELL(spell_enervation);
ASPELL(spell_evard_black_tentacles);
ASPELL(spell_extension_i);
ASPELL(spell_wish);
ASPELL(spell_fire_charm);
ASPELL(spell_fire_shield);
ASPELL(spell_cold_shield);
ASPELL(spell_imprisonment);
ASPELL(spell_fumble);
ASPELL(spell_hallucinatory_terrain);
ASPELL(spell_ice_storm);
ASPELL(spell_illusionary_wall);
ASPELL(spell_improved_invisibility);
ASPELL(spell_leomund_secure_shelter);
ASPELL(spell_magic_mirror);
ASPELL(spell_massmorph);
ASPELL(spell_minor_creation);
ASPELL(spell_minor_globe_of_invulnerability);
ASPELL(spell_monster_summoning_ii);
ASPELL(spell_otiluke_resilient_sphere);
ASPELL(spell_phantasmal_killer);
ASPELL(spell_meteor_swarm);
ASPELL(spell_polymorph_other);
ASPELL(spell_polymorph_self);
ASPELL(spell_rainbow_pattern);
ASPELL(spell_rary_mnemonic_enhancer);
ASPELL(spell_shadow_monsters);
ASPELL(spell_shout);
ASPELL(spell_solid_fog);
ASPELL(spell_stoneskin);
ASPELL(spell_vacancy);
ASPELL(spell_wall_of_fire);
ASPELL(spell_wall_of_ice);
ASPELL(spell_wizard_eye);
ASPELL(spell_advanced_illusion);
ASPELL(spell_airy_water);
ASPELL(spell_monster_summoning_vii);
ASPELL(spell_avoidance);
ASPELL(spell_bigby_interposing_hand);
ASPELL(spell_chaos);
ASPELL(spell_cloudkill);
ASPELL(spell_cone_of_cold);
ASPELL(spell_conjure_elemental);
ASPELL(spell_contact_other_plane);
ASPELL(spell_demi_shadow_monsters);
ASPELL(spell_dismissal);
ASPELL(spell_distance_distortion);
ASPELL(spell_domination);
ASPELL(spell_dream);
ASPELL(spell_extension_ii);
ASPELL(spell_fabricate);
ASPELL(spell_false_vision);
ASPELL(spell_feeblemind);
ASPELL(spell_hold_monster);
ASPELL(spell_leomund_lamentable_belaborment);
ASPELL(spell_leomund_secret_chest);
ASPELL(spell_magic_jar);
ASPELL(spell_major_creation);
ASPELL(spell_monster_summoning_iii);
ASPELL(spell_mordenkainen_faithful_hound);
ASPELL(spell_passwall);
ASPELL(spell_seeming);
ASPELL(spell_sending);
ASPELL(spell_shadow_door);
ASPELL(spell_shadow_magic);
ASPELL(spell_mordenkainen_disjunction);
ASPELL(spell_summon_shadow);
ASPELL(spell_telekinesis);
ASPELL(spell_teleport);
ASPELL(spell_transmute_rock_to_mud);
ASPELL(spell_transmute_mud_to_rock);
ASPELL(spell_wall_of_force);
ASPELL(spell_wall_of_iron);
ASPELL(spell_wall_of_stone);
ASPELL(spell_anti_magic_shell);
ASPELL(spell_bigby_forceful_hand);
ASPELL(spell_chain_lightning);
ASPELL(spell_power_word_kill);
ASPELL(spell_contingency);
ASPELL(spell_death_fog);
ASPELL(spell_death_spell);
ASPELL(spell_demi_shadow_magic);
ASPELL(spell_disintegrate);
ASPELL(spell_enchant_an_item);
ASPELL(spell_ensnarement);
ASPELL(spell_extension_iii);
ASPELL(spell_eyebite);
ASPELL(spell_geas);
ASPELL(spell_glassee);
ASPELL(spell_globe_of_invulnerability);
ASPELL(spell_guards_and_wards);
ASPELL(spell_invisible_stalker);
ASPELL(spell_legend_lore);
ASPELL(spell_mass_suggestion);
ASPELL(spell_mirage_arcana);
ASPELL(spell_mislead);
ASPELL(spell_monster_summoning_iv);
ASPELL(spell_mordenkainen_lucubration);
ASPELL(spell_move_earth);
ASPELL(spell_otiluke_freezing_sphere);
ASPELL(spell_prismatic_sphere);
ASPELL(spell_permanent_illusion);
ASPELL(spell_programmed_illusion);
ASPELL(spell_project_image);
ASPELL(spell_reincarnation);
ASPELL(spell_repulsion);
ASPELL(spell_shades);
ASPELL(spell_stone_to_flesh);
ASPELL(spell_flesh_to_stone);
ASPELL(spell_tenser_transformation);
ASPELL(spell_shape_change);
ASPELL(spell_veil);
ASPELL(spell_banishment);
ASPELL(spell_bigby_grasping_hand);
ASPELL(spell_charm_plants);
ASPELL(spell_control_undead);
ASPELL(spell_delayed_blast_fireball);
ASPELL(spell_drawmij_instant_summons);
ASPELL(spell_duo_dimension);
ASPELL(spell_finger_of_death);
ASPELL(spell_forcecage);
ASPELL(spell_limited_wish);
ASPELL(spell_mass_invisibility);
ASPELL(spell_monster_summoning_v);
ASPELL(spell_mordenkainen_magnificent_mansion);
ASPELL(spell_mordenkainen_sword);
ASPELL(spell_phase_door);
ASPELL(spell_power_word_stun);
ASPELL(spell_prismatic_spray);
ASPELL(spell_reverse_gravity);
ASPELL(spell_sequester);
ASPELL(spell_shadow_walk);
ASPELL(spell_simulacrum);
ASPELL(spell_spell_turning);
ASPELL(spell_statue);
ASPELL(spell_teleport_without_error);
ASPELL(spell_vanish);
ASPELL(spell_vision);
ASPELL(spell_antipathy_sympathy);
ASPELL(spell_bigby_clenched_fist);
ASPELL(spell_binding);
ASPELL(spell_clone);
ASPELL(spell_demand);
ASPELL(spell_glassteel);
ASPELL(spell_incendiary_cloud);
ASPELL(spell_mass_charm);
ASPELL(spell_maze);
ASPELL(spell_mind_blank);
ASPELL(spell_monster_summoning_vi);
ASPELL(spell_otiluke_telekinetic_sphere);
ASPELL(spell_otto_irresistible_dance);
ASPELL(spell_permanency);
ASPELL(spell_polymorph_any_object);
ASPELL(spell_power_word_blind);
ASPELL(spell_prismatic_wall);
ASPELL(spell_screen);
ASPELL(spell_serten_spell_immunity);
ASPELL(spell_sink);
ASPELL(spell_temporal_stasis);
ASPELL(spell_trap_the_soul);
ASPELL(spell_time_stop);
ASPELL(spell_bigby_crushing_hand);
ASPELL(spell_blindness);
ASPELL(spell_charm_person);
ASPELL(spell_cause_fear);
ASPELL(spell_undetectable_charm);

CSPELL(cast_spell_bless);
CSPELL(cast_spell_command);
CSPELL(cast_spell_create_water);
CSPELL(cast_spell_cure_light);
CSPELL(cast_spell_cause_light);
CSPELL(cast_spell_detect_evil);
CSPELL(cast_spell_detect_good);
CSPELL(cast_spell_detect_magic);
CSPELL(cast_spell_light);
CSPELL(cast_spell_darkness);
CSPELL(cast_spell_prot_from_evil);
CSPELL(cast_spell_prot_from_good);
CSPELL(cast_spell_purify_food_water);
CSPELL(cast_spell_contam_food_water);
CSPELL(cast_spell_remove_fear);
CSPELL(cast_spell_fear);
CSPELL(cast_spell_resist_cold);
CSPELL(cast_spell_sanctuary);
CSPELL(cast_spell_augury);
CSPELL(cast_spell_chant);
CSPELL(cast_spell_detect_charm);
CSPELL(cast_spell_combine);
CSPELL(cast_spell_find_traps);
CSPELL(cast_spell_hold_person);
CSPELL(cast_spell_know_align);
CSPELL(cast_spell_resist_fire);
CSPELL(cast_spell_silence_15);
CSPELL(cast_spell_slow_poison);
CSPELL(cast_spell_snake_charm);
CSPELL(cast_spell_speak_animals);
CSPELL(cast_spell_spirit_hammer);
CSPELL(cast_spell_animate_dead);
CSPELL(cast_spell_continual_light);
CSPELL(cast_spell_continual_darkness);
CSPELL(cast_spell_create_food);
CSPELL(cast_spell_detect_poison);
CSPELL(cast_spell_cure_blindness);
CSPELL(cast_spell_cause_deafness);
CSPELL(cast_spell_cause_blindness);
CSPELL(cast_spell_cure_deafness);
CSPELL(cast_spell_cure_disease);
CSPELL(cast_spell_cause_disease);
CSPELL(cast_spell_dispel_magic);
CSPELL(cast_spell_feign_death);
CSPELL(cast_spell_glyph_warding);
CSPELL(cast_spell_locate_object);
CSPELL(cast_spell_obscure_object);
CSPELL(cast_spell_prayer);
CSPELL(cast_spell_remove_curse);
CSPELL(cast_spell_curse);
CSPELL(cast_spell_speak_with_dead);
CSPELL(cast_spell_cure_serious);
CSPELL(cast_spell_cause_serious);
CSPELL(cast_spell_detect_lie);
CSPELL(cast_spell_undet_lie);
CSPELL(cast_spell_divination);
CSPELL(cast_spell_endure_cold);
CSPELL(cast_spell_lower_water);
CSPELL(cast_spell_raise_water);
CSPELL(cast_spell_neut_poison);
CSPELL(cast_spell_poison);
CSPELL(cast_spell_prot_evil_10);
CSPELL(cast_spell_prot_good_10);
CSPELL(cast_spell_speak_plants);
CSPELL(cast_spell_sticks_snakes);
CSPELL(cast_spell_snakes_sticks);
CSPELL(cast_spell_tongues);
CSPELL(cast_spell_rev_tongues);
CSPELL(cast_spell_atonement);
CSPELL(cast_spell_commune);
CSPELL(cast_spell_cure_critic);
CSPELL(cast_spell_cause_critic);
CSPELL(cast_spell_dispel_evil);
CSPELL(cast_spell_dispel_good);
CSPELL(cast_spell_flame_strike);
CSPELL(cast_spell_insect_plague);
CSPELL(cast_spell_plane_shift);
CSPELL(cast_spell_quest);
CSPELL(cast_spell_raise_dead);
CSPELL(cast_spell_slay_living);
CSPELL(cast_spell_true_seeing);
CSPELL(cast_spell_false_seeing);
CSPELL(cast_spell_aerial_servant);
CSPELL(cast_spell_animate_object);
CSPELL(cast_spell_blade_barrier);
CSPELL(cast_spell_conjure_animals);
CSPELL(cast_spell_find_path);
CSPELL(cast_spell_lose_path);
CSPELL(cast_spell_heal);
CSPELL(cast_spell_harm);
CSPELL(cast_spell_part_water);
CSPELL(cast_spell_speak_monsters);
CSPELL(cast_spell_stone_tell);
CSPELL(cast_spell_word_recall);
CSPELL(cast_spell_astral_spell);
CSPELL(cast_spell_control_weather);
CSPELL(cast_spell_earthquake);
CSPELL(cast_spell_holyword);
CSPELL(cast_spell_unholyword);
CSPELL(cast_spell_regenerate);
CSPELL(cast_spell_wither);
CSPELL(cast_spell_restoration);
CSPELL(cast_spell_energy_drain);
CSPELL(cast_spell_resurection);
CSPELL(cast_spell_destruction);
CSPELL(cast_spell_symbol);
CSPELL(cast_spell_wind_walk);
CSPELL(cast_spell_animal_friendship);
CSPELL(cast_spell_endure_heat);
CSPELL(cast_spell_detect_snares);
CSPELL(cast_spell_entangle);
CSPELL(cast_spell_faerie_fire);
CSPELL(cast_spell_invis_animals);
CSPELL(cast_spell_locate_animal);
CSPELL(cast_spell_pass_without_trace);
CSPELL(cast_spell_invis_undead);
CSPELL(cast_spell_magical_stone);
CSPELL(cast_spell_aid);
CSPELL(cast_spell_shillelagh);
CSPELL(cast_spell_dust_devil);
CSPELL(cast_spell_barkskin);
CSPELL(cast_spell_charm_mammal);
CSPELL(cast_spell_fire_trap);
CSPELL(cast_spell_heat_metal);
CSPELL(cast_spell_chill_metal);
CSPELL(cast_spell_locate_plants);
CSPELL(cast_spell_obscurement);
CSPELL(cast_spell_produce_flame);
CSPELL(cast_spell_trip);
CSPELL(cast_spell_warp_wood);
CSPELL(cast_spell_call_lightning);
CSPELL(cast_spell_hold_animal);
CSPELL(cast_spell_plant_growth);
CSPELL(cast_spell_prot_fire);
CSPELL(cast_spell_pyrotechnics);
CSPELL(cast_spell_snare);
CSPELL(cast_spell_stone_shape);
CSPELL(cast_spell_summon_insects);
CSPELL(cast_spell_tree);
CSPELL(cast_spell_water_breathing);
CSPELL(cast_spell_air_breathing);
CSPELL(cast_spell_animal_summ1);
CSPELL(cast_spell_call_wood_beings);
CSPELL(cast_spell_cont_temp_10);
CSPELL(cast_spell_halluc_forest);
CSPELL(cast_spell_hold_plant);
CSPELL(cast_spell_plant_door);
CSPELL(cast_spell_prod_fire);
CSPELL(cast_spell_quench_fire);
CSPELL(cast_spell_prot_lightning);
CSPELL(cast_spell_repel_insects);
CSPELL(cast_spell_animal_growth);
CSPELL(cast_spell_reduce_animal);
CSPELL(cast_spell_anim_summ2);
CSPELL(cast_spell_anti_plant_shell);
CSPELL(cast_spell_commune_nature);
CSPELL(cast_spell_control_winds);
CSPELL(cast_spell_enthrall);
CSPELL(cast_spell_pass_plant);
CSPELL(cast_spell_rock_mud);
CSPELL(cast_spell_mud_rock);
CSPELL(cast_spell_wall_fire);
CSPELL(cast_spell_anim_summ3);
CSPELL(cast_spell_anti_anim_shell);
CSPELL(cast_spell_conj_fire_elemental);
CSPELL(cast_spell_dismiss_fire_elemental);
CSPELL(cast_spell_flame_blade);
CSPELL(cast_spell_fire_seeds);
CSPELL(cast_spell_trans_via_plants);
CSPELL(cast_spell_turn_wood);
CSPELL(cast_spell_wall_thorns);
CSPELL(cast_spell_weather_summoning);
CSPELL(cast_spell_animate_rock);
CSPELL(cast_spell_chariot_sustarre);
CSPELL(cast_spell_confusion);
CSPELL(cast_spell_conj_earth_elemental);
CSPELL(cast_spell_dismiss_earth_elemental);
CSPELL(cast_spell_goodberry);
CSPELL(cast_spell_creeping_doom);
CSPELL(cast_spell_badberry);
CSPELL(cast_spell_fire_storm);
CSPELL(cast_spell_fire_quench);
CSPELL(cast_spell_reincarnate);
CSPELL(cast_spell_trans_metal_wood);
CSPELL(cast_spell_messenger);
CSPELL(cast_spell_withdraw);
CSPELL(cast_spell_wyvern_watch);
CSPELL(cast_spell_flame_walk);
CSPELL(cast_spell_magical_vestment);
CSPELL(cast_spell_meld_into_stone);
CSPELL(cast_spell_neg_plane_prot);
CSPELL(cast_spell_remove_para);
CSPELL(cast_spell_spike_growth);
CSPELL(cast_spell_starshine);
CSPELL(cast_spell_water_walk);
CSPELL(cast_spell_abjure);
CSPELL(cast_spell_cloak_bravery);
CSPELL(cast_spell_free_action);
CSPELL(cast_spell_giant_insect);
CSPELL(cast_spell_small_insect);
CSPELL(cast_spell_imbue_spell_ability);
CSPELL(cast_spell_reflecting_pool);
CSPELL(cast_spell_spell_immunity);
CSPELL(cast_spell_air_walk);
CSPELL(cast_spell_magic_font);
CSPELL(cast_spell_moonbeam);
CSPELL(cast_spell_rainbow);
CSPELL(cast_spell_spike_stones);
CSPELL(cast_spell_forbiddance);
CSPELL(cast_spell_heros_feast);
CSPELL(cast_spell_liveoak);
CSPELL(cast_spell_water_to_dust);
CSPELL(cast_spell_dust_to_water);
CSPELL(cast_spell_changestaff);
CSPELL(cast_spell_exaction);
CSPELL(cast_spell_gate);
CSPELL(cast_spell_sunray);
CSPELL(cast_spell_succor);
CSPELL(cast_spell_wood_to_metal);
CSPELL(cast_spell_affect_normal_fires);
CSPELL(cast_spell_alarm);
CSPELL(cast_spell_armor);
CSPELL(cast_spell_audible_glamer);
CSPELL(cast_spell_burning_hands);
CSPELL(cast_spell_cantrip);
CSPELL(cast_spell_change_self);
CSPELL(cast_spell_chill_touch);
CSPELL(cast_spell_color_spray);
CSPELL(cast_spell_comprehend_languages);
CSPELL(cast_spell_obscure_languages);
CSPELL(cast_spell_dancing_lights);
CSPELL(cast_spell_detect_undead);
CSPELL(cast_spell_enlarge);
CSPELL(cast_spell_reduce);
CSPELL(cast_spell_erase);
CSPELL(cast_spell_feather_fall);
CSPELL(cast_spell_find_familiar);
CSPELL(cast_spell_friends);
CSPELL(cast_spell_gaze_reflection);
CSPELL(cast_spell_grease);
CSPELL(cast_spell_hold_portal);
CSPELL(cast_spell_hypnotism);
CSPELL(cast_spell_identify);
CSPELL(cast_spell_jump);
CSPELL(cast_spell_crystalbrittle);
CSPELL(cast_spell_magic_missile);
CSPELL(cast_spell_mending);
CSPELL(cast_spell_message);
CSPELL(cast_spell_mount);
CSPELL(cast_spell_nystul_magical_aura);
CSPELL(cast_spell_phantasmal_force);
CSPELL(cast_spell_read_magic);
CSPELL(cast_spell_shield);
CSPELL(cast_spell_shocking_grasp);
CSPELL(cast_spell_sleep);
CSPELL(cast_spell_spider_climb);
CSPELL(cast_spell_spook);
CSPELL(cast_spell_taunt);
CSPELL(cast_spell_tenser_floating_disc);
CSPELL(cast_spell_unseen_servant);
CSPELL(cast_spell_ventriloquism);
CSPELL(cast_spell_wall_of_fog);
CSPELL(cast_spell_wizard_mark);
CSPELL(cast_spell_alter_self);
CSPELL(cast_spell_bind);
CSPELL(cast_spell_blur);
CSPELL(cast_spell_deafness);
CSPELL(cast_spell_deeppockets);
CSPELL(cast_spell_detect_invisibility);
CSPELL(cast_spell_esp);
CSPELL(cast_spell_flaming_sphere);
CSPELL(cast_spell_fog_cloud);
CSPELL(cast_spell_fools_gold);
CSPELL(cast_spell_forget);
CSPELL(cast_spell_glitterdust);
CSPELL(cast_spell_hypnotic_pattern);
CSPELL(cast_spell_improved_phantasmal_force);
CSPELL(cast_spell_invisibility);
CSPELL(cast_spell_irritation);
CSPELL(cast_spell_knock);
CSPELL(cast_spell_leomund_trap);
CSPELL(cast_spell_levitate);
CSPELL(cast_spell_magic_mouth);
CSPELL(cast_spell_melf_acid_arrow);
CSPELL(cast_spell_mirror_image);
CSPELL(cast_spell_misdirection);
CSPELL(cast_spell_protection_from_cantrips);
CSPELL(cast_spell_weird);
CSPELL(cast_spell_ray_of_enfeeblement);
CSPELL(cast_spell_rope_trick);
CSPELL(cast_spell_scare);
CSPELL(cast_spell_shatter);
CSPELL(cast_spell_spectral_hand);
CSPELL(cast_spell_stinking_cloud);
CSPELL(cast_spell_strength);
CSPELL(cast_spell_summon_swarm);
CSPELL(cast_spell_tasha_uncontrollable_hideous_laughter);
CSPELL(cast_spell_web);
CSPELL(cast_spell_whispering_wind);
CSPELL(cast_spell_wizard_lock);
CSPELL(cast_spell_blink);
CSPELL(cast_spell_clairaudience);
CSPELL(cast_spell_clairvoyance);
CSPELL(cast_spell_delude);
CSPELL(cast_spell_explosive_runes);
CSPELL(cast_spell_fireball);
CSPELL(cast_spell_flame_arrow);
CSPELL(cast_spell_fly);
CSPELL(cast_spell_gust_of_wind);
CSPELL(cast_spell_haste);
CSPELL(cast_spell_hold_undead);
CSPELL(cast_spell_illusionary_script);
CSPELL(cast_spell_infravision);
CSPELL(cast_spell_invisibility_10);
CSPELL(cast_spell_item);
CSPELL(cast_spell_leomund_tiny_hut);
CSPELL(cast_spell_lightning_bolt);
CSPELL(cast_spell_melf_minute_meteors);
CSPELL(cast_spell_monster_summoning_i);
CSPELL(cast_spell_non_detection);
CSPELL(cast_spell_phantom_steed);
CSPELL(cast_spell_protection_from_normal_missiles);
CSPELL(cast_spell_secret_page);
CSPELL(cast_spell_sepia_snake_sigil);
CSPELL(cast_spell_slow);
CSPELL(cast_spell_spectral_force);
CSPELL(cast_spell_suggestion);
CSPELL(cast_spell_vampiric_touch);
CSPELL(cast_spell_wind_wall);
CSPELL(cast_spell_wraithform);
CSPELL(cast_spell_charm_monster);
CSPELL(cast_spell_foresight);
CSPELL(cast_spell_contagion);
CSPELL(cast_spell_detect_scrying);
CSPELL(cast_spell_dig);
CSPELL(cast_spell_dimension_door);
CSPELL(cast_spell_emotion);
CSPELL(cast_spell_enchanted_weapon);
CSPELL(cast_spell_enervation);
CSPELL(cast_spell_evard_black_tentacles);
CSPELL(cast_spell_extension_i);
CSPELL(cast_spell_wish);
CSPELL(cast_spell_fire_charm);
CSPELL(cast_spell_fire_shield);
CSPELL(cast_spell_cold_shield);
CSPELL(cast_spell_imprisonment);
CSPELL(cast_spell_fumble);
CSPELL(cast_spell_hallucinatory_terrain);
CSPELL(cast_spell_ice_storm);
CSPELL(cast_spell_illusionary_wall);
CSPELL(cast_spell_improved_invisibility);
CSPELL(cast_spell_leomund_secure_shelter);
CSPELL(cast_spell_magic_mirror);
CSPELL(cast_spell_massmorph);
CSPELL(cast_spell_minor_creation);
CSPELL(cast_spell_minor_globe_of_invulnerability);
CSPELL(cast_spell_monster_summoning_ii);
CSPELL(cast_spell_otiluke_resilient_sphere);
CSPELL(cast_spell_phantasmal_killer);
CSPELL(cast_spell_meteor_swarm);
CSPELL(cast_spell_polymorph_other);
CSPELL(cast_spell_polymorph_self);
CSPELL(cast_spell_rainbow_pattern);
CSPELL(cast_spell_rary_mnemonic_enhancer);
CSPELL(cast_spell_shadow_monsters);
CSPELL(cast_spell_shout);
CSPELL(cast_spell_solid_fog);
CSPELL(cast_spell_stoneskin);
CSPELL(cast_spell_vacancy);
CSPELL(cast_spell_wall_of_fire);
CSPELL(cast_spell_wall_of_ice);
CSPELL(cast_spell_wizard_eye);
CSPELL(cast_spell_advanced_illusion);
CSPELL(cast_spell_airy_water);
CSPELL(cast_spell_monster_summoning_vii);
CSPELL(cast_spell_avoidance);
CSPELL(cast_spell_bigby_interposing_hand);
CSPELL(cast_spell_chaos);
CSPELL(cast_spell_cloudkill);
CSPELL(cast_spell_cone_of_cold);
CSPELL(cast_spell_conjure_elemental);
CSPELL(cast_spell_contact_other_plane);
CSPELL(cast_spell_demi_shadow_monsters);
CSPELL(cast_spell_dismissal);
CSPELL(cast_spell_distance_distortion);
CSPELL(cast_spell_domination);
CSPELL(cast_spell_dream);
CSPELL(cast_spell_extension_ii);
CSPELL(cast_spell_fabricate);
CSPELL(cast_spell_false_vision);
CSPELL(cast_spell_feeblemind);
CSPELL(cast_spell_hold_monster);
CSPELL(cast_spell_leomund_lamentable_belaborment);
CSPELL(cast_spell_leomund_secret_chest);
CSPELL(cast_spell_magic_jar);
CSPELL(cast_spell_major_creation);
CSPELL(cast_spell_monster_summoning_iii);
CSPELL(cast_spell_mordenkainen_faithful_hound);
CSPELL(cast_spell_passwall);
CSPELL(cast_spell_seeming);
CSPELL(cast_spell_sending);
CSPELL(cast_spell_shadow_door);
CSPELL(cast_spell_shadow_magic);
CSPELL(cast_spell_mordenkainen_disjunction);
CSPELL(cast_spell_summon_shadow);
CSPELL(cast_spell_telekinesis);
CSPELL(cast_spell_teleport);
CSPELL(cast_spell_transmute_rock_to_mud);
CSPELL(cast_spell_transmute_mud_to_rock);
CSPELL(cast_spell_wall_of_force);
CSPELL(cast_spell_wall_of_iron);
CSPELL(cast_spell_wall_of_stone);
CSPELL(cast_spell_anti_magic_shell);
CSPELL(cast_spell_bigby_forceful_hand);
CSPELL(cast_spell_chain_lightning);
CSPELL(cast_spell_power_word_kill);
CSPELL(cast_spell_contingency);
CSPELL(cast_spell_death_fog);
CSPELL(cast_spell_death_spell);
CSPELL(cast_spell_demi_shadow_magic);
CSPELL(cast_spell_disintegrate);
CSPELL(cast_spell_enchant_an_item);
CSPELL(cast_spell_ensnarement);
CSPELL(cast_spell_extension_iii);
CSPELL(cast_spell_eyebite);
CSPELL(cast_spell_geas);
CSPELL(cast_spell_glassee);
CSPELL(cast_spell_globe_of_invulnerability);
CSPELL(cast_spell_guards_and_wards);
CSPELL(cast_spell_invisible_stalker);
CSPELL(cast_spell_legend_lore);
CSPELL(cast_spell_mass_suggestion);
CSPELL(cast_spell_mirage_arcana);
CSPELL(cast_spell_mislead);
CSPELL(cast_spell_monster_summoning_iv);
CSPELL(cast_spell_mordenkainen_lucubration);
CSPELL(cast_spell_move_earth);
CSPELL(cast_spell_otiluke_freezing_sphere);
CSPELL(cast_spell_prismatic_sphere);
CSPELL(cast_spell_permanent_illusion);
CSPELL(cast_spell_programmed_illusion);
CSPELL(cast_spell_project_image);
CSPELL(cast_spell_reincarnation);
CSPELL(cast_spell_repulsion);
CSPELL(cast_spell_shades);
CSPELL(cast_spell_stone_to_flesh);
CSPELL(cast_spell_flesh_to_stone);
CSPELL(cast_spell_tenser_transformation);
CSPELL(cast_spell_shape_change);
CSPELL(cast_spell_veil);
CSPELL(cast_spell_banishment);
CSPELL(cast_spell_bigby_grasping_hand);
CSPELL(cast_spell_charm_plants);
CSPELL(cast_spell_control_undead);
CSPELL(cast_spell_delayed_blast_fireball);
CSPELL(cast_spell_drawmij_instant_summons);
CSPELL(cast_spell_duo_dimension);
CSPELL(cast_spell_finger_of_death);
CSPELL(cast_spell_forcecage);
CSPELL(cast_spell_limited_wish);
CSPELL(cast_spell_mass_invisibility);
CSPELL(cast_spell_monster_summoning_v);
CSPELL(cast_spell_mordenkainen_magnificent_mansion);
CSPELL(cast_spell_mordenkainen_sword);
CSPELL(cast_spell_phase_door);
CSPELL(cast_spell_power_word_stun);
CSPELL(cast_spell_prismatic_spray);
CSPELL(cast_spell_reverse_gravity);
CSPELL(cast_spell_sequester);
CSPELL(cast_spell_shadow_walk);
CSPELL(cast_spell_simulacrum);
CSPELL(cast_spell_spell_turning);
CSPELL(cast_spell_statue);
CSPELL(cast_spell_teleport_without_error);
CSPELL(cast_spell_vanish);
CSPELL(cast_spell_vision);
CSPELL(cast_spell_antipathy_sympathy);
CSPELL(cast_spell_bigby_clenched_fist);
CSPELL(cast_spell_binding);
CSPELL(cast_spell_clone);
CSPELL(cast_spell_demand);
CSPELL(cast_spell_glassteel);
CSPELL(cast_spell_incendiary_cloud);
CSPELL(cast_spell_mass_charm);
CSPELL(cast_spell_maze);
CSPELL(cast_spell_mind_blank);
CSPELL(cast_spell_monster_summoning_vi);
CSPELL(cast_spell_otiluke_telekinetic_sphere);
CSPELL(cast_spell_otto_irresistible_dance);
CSPELL(cast_spell_permanency);
CSPELL(cast_spell_polymorph_any_object);
CSPELL(cast_spell_power_word_blind);
CSPELL(cast_spell_prismatic_wall);
CSPELL(cast_spell_screen);
CSPELL(cast_spell_serten_spell_immunity);
CSPELL(cast_spell_sink);
CSPELL(cast_spell_temporal_stasis);
CSPELL(cast_spell_trap_the_soul);
CSPELL(cast_spell_time_stop);
CSPELL(cast_spell_bigby_crushing_hand);
CSPELL(cast_spell_blindness);
CSPELL(cast_spell_charm_person);
CSPELL(cast_spell_undetectable_charm);
CSPELL(cast_spell_cause_fear);

// General Routines
AROUTINE(r_none);
AROUTINE(r_cure);

// First Level Magic-User Spells
AROUTINE(r_armor);
AROUTINE(r_charm);
AROUTINE(r_detect_magic);
AROUTINE(r_detect_poison);
AROUTINE(r_gaze_reflection);
AROUTINE(r_protection_from_evil);
AROUTINE(r_protection_from_good);
AROUTINE(r_shield);
AROUTINE(r_shocking_grasp);
AROUTINE(r_sleep);
AROUTINE(r_spider_climb);

// Second Level Magic-User Spells

AROUTINE(r_blindness);
AROUTINE(r_blur);
AROUTINE(r_detect_evil);
AROUTINE(r_detect_good);
AROUTINE(r_detect_invisibility);
AROUTINE(r_invisibility);
AROUTINE(r_levitate);
AROUTINE(r_ray_of_enfeeblement);
AROUTINE(r_strength);

// Third Level Magic-User Spells

AROUTINE(r_blink);
AROUTINE(r_fly);
AROUTINE(r_haste);
AROUTINE(r_infravision);
AROUTINE(r_mass_invisibility);
AROUTINE(r_slow);
AROUTINE(r_water_breathing);
AROUTINE(r_wraithform); 

// Fourth Level Magic-User Spells

AROUTINE(r_cold_shield);
AROUTINE(r_fire_shield);
AROUTINE(r_minor_globe_of_invulnerability);

// Fifth Level Magic-User Spells

AROUTINE(r_feeblemind);

// Sixth Level Magic-User Spells

AROUTINE(r_globe_of_invulnerability);

// Seventh Level Magic-User Spells


// Eighth Level Magic-User Spells

AROUTINE(r_power_word_blind);

// Ninth Level Magic-User Spells

// First Level Cleric Spells

AROUTINE(r_bless);
AROUTINE(r_curse);
AROUTINE(r_faerie_fire);
AROUTINE(r_invis_animals);
AROUTINE(r_invis_undead);
AROUTINE(r_sanctuary);

// Second Level Cleric Spells

AROUTINE(r_aid);
AROUTINE(r_barkskin);
AROUTINE(r_detect_charm);
AROUTINE(r_undetectable_charm);

// Third Level Cleric Spells

AROUTINE(r_cause_deafness);
AROUTINE(r_cause_blindness);
AROUTINE(r_cure_deafness);
AROUTINE(r_cure_blindness);

// Fourth Level Cleric Spells


// Fifth Level Cleric Spells


// Sixth Level Cleric Spells

AROUTINE(r_heal);

// Seventh Level Cleric Spells



/* basic magic calling functions */

int find_spells_num(char *name);


void mag_unaffects(int level, struct char_data *ch, struct char_data *victim,
		   int spellnum, int type);

int call_magic(struct char_data *caster, struct char_data *cvict,
	   struct obj_data *ovict, int spellnum, int level, int casttype,
	       struct location_data *loc);

int cast_spell(struct char_data *ch, struct char_data *tch,
	       struct obj_data *tobj, int spellnum);


/* other prototypes */
void spell_level(int spell, int class, int level, int components);
void init_spell_levels(void);
char *spell_name(int num);
byte is_enemy(struct char_data *ch, struct char_data *victim);
byte affectarea(struct char_data *caster, struct char_data *vict,
	struct location_data *loc2, struct char_data *target, int spell);
